# include "all.h"



unsigned long int ay_sys_getword(unsigned char *p)
{
    return *p | ((*(p + 1)) << 8);
}

void ay_sys_writeword(unsigned char *p, unsigned int val)
{
    *p = (unsigned char)(val & 0xff);
    *(p + 1) = (unsigned char)((val >> 8) & 0xff);
}

///unsigned char c1, c2, c3;

char copy[16];

void ay_writeay(unsigned char reg, unsigned char val)
{
     if ((reg==0xff) && (val==0xff))
      {
             output(0xFFFD, 8); output(0xBFFD, copy[8]);  
             output(0xFFFD, 9); output(0xBFFD, copy[9]);  
             output(0xFFFD, 10); output(0xBFFD, copy[10]);  
             
             return;
      }

      copy[reg] = val;

/*
      if (reg==AY_CHNL_A_VOL)        c1 = val;
      else
      if (reg==AY_CHNL_B_VOL)        c2 = val;
      else
      if (reg==AY_CHNL_C_VOL)        c3 = val;
  */
           
     output(0xFFFD, reg);
     output(0xBFFD, val);
}

char ay_readay(unsigned char reg)
{
      return(copy[reg]);


      //output(0xFFFD, reg);
      //return(input(0xBFFD));
      
}



typedef struct 
{
    unsigned char PT2_Delay;
    unsigned char PT2_NumberOfPositions;
    unsigned char PT2_LoopPosition;
    unsigned char PT2_SamplesPointers0[64];
    unsigned char PT2_OrnamentsPointers0[32];
    unsigned char PT2_PatternsPointer0, PT2_PatternsPointer1;
    char PT2_MusicName[30];
    unsigned char PT2_PositionList[65535 - 131];
} PT2_File;

typedef struct 
{
    unsigned char DelayCounter, Delay, CurrentPosition;
} PT2_Parameters;


typedef struct 
{
    unsigned int Address_In_Pattern, OrnamentPointer, SamplePointer, Ton;
    unsigned char Loop_Ornament_Position, Ornament_Length, Position_In_Ornament, Loop_Sample_Position, Sample_Length, Position_In_Sample, Volume, Number_Of_Notes_To_Skip, Note, Slide_To_Note,Amplitude;
    signed char Current_Ton_Sliding, Ton_Delta;
    long int GlissType;
    bool Envelope_Enabled, Enabled;
    signed char Glissade, Addition_To_Noise, Note_Skip_Counter;
} PT2_Channel_Parameters;

typedef struct 
{
    PT2_Parameters PT2;
    PT2_Channel_Parameters PT2_A, PT2_B, PT2_C;
} PT2_SongInfo;


#define PT2_A ((PT2_SongInfo *)info->data)->PT2_A
#define PT2_B ((PT2_SongInfo *)info->data)->PT2_B
#define PT2_C ((PT2_SongInfo *)info->data)->PT2_C
#define PT2 ((PT2_SongInfo *)info->data)->PT2

#define PT2_SamplesPointers(x) (header->PT2_SamplesPointers0 [(x) * 2] | (header->PT2_SamplesPointers0 [(x) * 2 + 1] << 8))
#define PT2_OrnamentsPointers(x) (header->PT2_OrnamentsPointers0 [(x) * 2] | (header->PT2_OrnamentsPointers0 [(x) * 2 + 1] << 8))

//#define PT2_OrnamentsPointers(x) (header->PT2_OrnamentsPointers0 [(x) * 2] + (header->PT2_OrnamentsPointers0 [(x) * 2 + 1] * 256))

#define PT2_PositionList(x) (header->PT2_PositionList [(x)])
#define PT2_PatternsPointer (header->PT2_PatternsPointer0 | (header->PT2_PatternsPointer1 << 8))
#define PT2_Delay (header->PT2_Delay)
#define PT2_NumberOfPositions (header->PT2_NumberOfPositions)
#define PT2_LoopPosition (header->PT2_LoopPosition)

PT2_SongInfo PT2_SongInfoV;

void PT2_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    PT2_File * header = (PT2_File *)module;
    
    info->data = (void *)& PT2_SongInfoV;
    
	
    memset(&PT2_A, 0, sizeof(PT2_Channel_Parameters));
    memset(&PT2_B, 0, sizeof(PT2_Channel_Parameters));
    memset(&PT2_C, 0, sizeof(PT2_Channel_Parameters));
    
    PT2.DelayCounter = 1;
    PT2.Delay = PT2_Delay;
    PT2.CurrentPosition = 0;

    PT2_A.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer+ PT2_PositionList(0) * 6]);
    PT2_B.Address_In_Pattern = ay_sys_getword(&module [PT2_PatternsPointer + PT2_PositionList(0) * 6 + 2]);
    PT2_C.Address_In_Pattern = ay_sys_getword(&module [PT2_PatternsPointer + PT2_PositionList(0) * 6 + 4]);

    PT2_A.OrnamentPointer = PT2_OrnamentsPointers(0);
    PT2_A.Ornament_Length = module[PT2_A.OrnamentPointer];
    PT2_A.OrnamentPointer++;
    PT2_A.Loop_Ornament_Position = module[PT2_A.OrnamentPointer];
    PT2_A.OrnamentPointer++;
    PT2_A.Envelope_Enabled = false;
    PT2_A.Position_In_Sample = 0;
    PT2_A.Position_In_Ornament = 0;
    PT2_A.Addition_To_Noise = 0;
    PT2_A.Glissade = 0;
    PT2_A.Current_Ton_Sliding=0;
    PT2_A.GlissType = 0;
    PT2_A.Enabled = false;
    PT2_A.Number_Of_Notes_To_Skip = 0;
    PT2_A.Note_Skip_Counter = 0;
    PT2_A.Volume = 15;
    PT2_A.Ton = 0;

    PT2_B.OrnamentPointer = PT2_A.OrnamentPointer;
    PT2_B.Loop_Ornament_Position = PT2_A.Loop_Ornament_Position;
    PT2_B.Ornament_Length = PT2_A.Ornament_Length;
    PT2_B.Envelope_Enabled = false;
    PT2_B.Position_In_Sample = 0;
    PT2_B.Position_In_Ornament = 0;
    PT2_B.Addition_To_Noise = 0;
    PT2_B.Glissade = 0;
    PT2_B.Current_Ton_Sliding = 0;
    PT2_B.GlissType = 0;
    PT2_B.Enabled = false;
    PT2_B.Number_Of_Notes_To_Skip = 0;
    PT2_B.Note_Skip_Counter = 0;
    PT2_B.Volume = 15;
    PT2_B.Ton = 0;

    PT2_C.OrnamentPointer = PT2_A.OrnamentPointer;
    PT2_C.Loop_Ornament_Position = PT2_A.Loop_Ornament_Position;
    PT2_C.Ornament_Length = PT2_A.Ornament_Length;
    PT2_C.Envelope_Enabled = false;
    PT2_C.Position_In_Sample = 0;
    PT2_C.Position_In_Ornament = 0;
    PT2_C.Addition_To_Noise = 0;
    PT2_C.Glissade = 0;
    PT2_C.Current_Ton_Sliding = 0;
    PT2_C.GlissType = 0;
    PT2_C.Enabled = false;
    PT2_C.Number_Of_Notes_To_Skip = 0;
    PT2_C.Note_Skip_Counter = 0;
    PT2_C.Volume = 15;
    PT2_C.Ton = 0;
    
//    ay_resetay(&info, 0);
}

unsigned char PT2_Detect0(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    int j, j1, j2;
    long int F_Length;
    

    
    PT2_File * header = (PT2_File *)module;
    
        
    //return true;
    
    
    if(length < 132)
        return false;
        
     //s->err  = 10;
        
    if(PT2_PatternsPointer> length)
        return false;
        
    // s->err  = 20;
    
    if(module[PT2_PatternsPointer-1] != 255)
        return false;
    
    //s->err  = 30;    
        
    if(PT2_SamplesPointers(0) != 0)
        return false;
        
   // s->err  = 50;    
    
    j = 0;
    memcpy((char *)&j, (char *)&module[PT2_OrnamentsPointers(0)], 3);
    if(j != 1)
    {
       // memcpy(&s->counter, &module[0x0779], 2); 
        return false;
    }
        
    //s->err = 90;

    j = ay_sys_getword(&module[PT2_PatternsPointer]);
    if(j > length)
        return false;
    if(j - (long int)(PT2_PatternsPointer) <= 0)
        return false;
    if(((j - (long int)(PT2_PatternsPointer)) % 6) != 2)
        return false;

   // s->err  = 190;


    j1 = 0;
    j2 = 0;
    while(((j2 < 256) && (j2 <= length - 131)) && (header->PT2_PositionList[j2] < 128))
    {
        if((unsigned long)(j1) < header->PT2_PositionList[j2])
            j1 = header->PT2_PositionList[j2];
        j2++;
    }
    if(((j - (long int)(PT2_PatternsPointer)) / 6) != j1 + 1)
        return false;

   // s->err  = 290;


    j = 15;
    while((j > 0) && (PT2_OrnamentsPointers(j) == 0))
        j--;
    F_Length = PT2_OrnamentsPointers(j) + module[PT2_OrnamentsPointers(j)] + 2;
    if(F_Length > (length+256))
    {
       //  s->err  =F_Length;
        return false;
        }

    PT2_NumberOfPositions = j2;
    return true;
}

bool PT2_Detect1(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    int j, j1, j2, j3;
    long int F_Length;
    
    
   // return false;
    
    PT2_File *header = (PT2_File *)module;
    
    if(length < 132)
        return false;
    if(PT2_PatternsPointer > length)
        return false;
    if(module[PT2_PatternsPointer-1] != 255)
        return false;
    if(PT2_SamplesPointers(0) != 0)
        return false;

     

    j3 = PT2_SamplesPointers(0);
    if(PT2_OrnamentsPointers(0) - j3 - 2 > length)
        return false;
    
    // s->err = 400;
        
    if(PT2_OrnamentsPointers(0)- j3 < 0)
        return false;

    // s->err = 500;

    j = 0;
    memcpy((char *)&j, (char *)&module[PT2_OrnamentsPointers(0)], 3);
    if(j != 1)
        return false;
  
    //s->err = 1000;

    j = ay_sys_getword(&module[PT2_PatternsPointer]);
    j -= j3;
    if(j > length)
        return false;
    
    //s->err = 2000; 
       
    if(j - (long int)(PT2_PatternsPointer) <= 0)
        return false;
        
    //s->err = 3000;
        
    if(((j - (long int)(PT2_PatternsPointer)) % 6) != 2)
        return false;

   //s->err = 4000;

    j1 = 0;
    j2 = 0;
    while(((j2 < 256) && (j2 <= length - 131)) && (header->PT2_PositionList[j2] < 128))
    {
        if((unsigned long)(j1) < header->PT2_PositionList[j2])
            j1 = header->PT2_PositionList[j2];
        j2++;
    }
    if(((j - (long int)(PT2_PatternsPointer)) / 6) != j1 + 1)
        return false;

    j = 15;
    while((j > 0) && (PT2_OrnamentsPointers(j) == j3))
        j--;
    F_Length = PT2_OrnamentsPointers(j) - j3 + module[PT2_OrnamentsPointers(j) - j3] + 2;
    if(F_Length > length + 1)
        return false;

    PT2_NumberOfPositions = j2;
    for(j = 0; j < 32; j++)
    {
        ay_sys_writeword(&header->PT2_SamplesPointers0[j * 2], PT2_SamplesPointers(j) - j3);
    }
    for(j = 0; j < 16; j++)
    {
        ay_sys_writeword(&header->PT2_OrnamentsPointers0[j * 2], PT2_OrnamentsPointers(j) - j3);
    }
    for(j2 = 0; j2 < j1 * 3 + 1; j2++)
    {
        j = ay_sys_getword(&module[PT2_PatternsPointer+j2 * 2]);
        j -= j3;
        ay_sys_writeword(&module[PT2_PatternsPointer+j2 * 2], j);
    }
    return true;
}

bool PT2_Detect(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    if(!PT2_Detect0(module, length, s))
        if(!PT2_Detect1(module, length, s))
            return false;
            
    strcpy(s->player, "Pro Tracker v2");
            
    return true;
}

const unsigned int PT2_Table[96] =
{ 0xef8, 0xe10, 0xd60, 0xc80, 0xbd8, 0xb28, 0xa88, 0x9f0, 0x960, 0x8e0, 0x858, 0x7e0, 0x77c, 0x708, 0x6b0, 0x640, 0x5ec, 0x594, 0x544, 0x4f8, 0x4b0, 0x470, 0x42c, 0x3fd, 0x3be, 0x384, 0x358, 
 0x320, 0x2f6, 0x2ca, 0x2a2, 0x27c, 0x258, 0x238, 0x216, 0x1f8, 0x1df, 0x1c2, 0x1ac, 0x190, 0x17b, 0x165, 0x151, 0x13e, 0x12c, 0x11c, 0x10a, 0xfc, 0xef, 0xe1, 0xd6, 0xc8, 0xbd, 0xb2, 0xa8, 0x9f,
 0x96, 0x8e, 0x85, 0x7e, 0x77, 0x70, 0x6b, 0x64, 0x5e, 0x59, 0x54, 0x4f, 0x4b, 0x47, 0x42, 0x3f, 0x3b, 0x38, 0x35, 0x32, 0x2f, 0x2c, 0x2a, 0x27, 0x25, 0x23, 0x21, 0x1f, 0x1d, 0x1c, 0x1a, 0x19,
 0x17, 0x16, 0x15, 0x13, 0x12, 0x11, 0x10, 0xf };

void PT2_PatternInterpreter(AYSongInfo * info, PT2_Channel_Parameters * chan)
{
    unsigned char * module = info->module;
    PT2_File * header = (PT2_File *)module;
    bool quit, gliss;
	unsigned char val;
	
    quit = false;
    gliss = false;
    
	do
    {
        val = module[chan->Address_In_Pattern];
        if(val >= 0xe1)
        {
            chan->SamplePointer = PT2_SamplesPointers(val - 0xe0);
            chan->Sample_Length = module[chan->SamplePointer];
            chan->SamplePointer++;
            chan->Loop_Sample_Position = module[chan->SamplePointer];
            chan->SamplePointer++;
        }
        else if(val == 0xe0)
        {
            chan->Position_In_Sample = 0;
            chan->Position_In_Ornament = 0;
            chan->Current_Ton_Sliding = 0;
            chan->GlissType = 0;
            chan->Enabled = false;
            quit = true;
        }
        else if(val >= 0x80 && val <= 0xdf)
        {
            chan->Position_In_Sample = 0;
            chan->Position_In_Ornament = 0;
            chan->Current_Ton_Sliding = 0;
            if(gliss)
            {
                chan->Slide_To_Note = val - 0x80;
                if(chan->GlissType == 1)
                    chan->Note = chan->Slide_To_Note;
            }
            else
            {
                chan->Note = val - 0x80;
                chan->GlissType = 0;
            }
            chan->Enabled = true;
            quit = true;
        }
        else if(val == 0x7f)
            chan->Envelope_Enabled = false;
        else if(val >= 0x71 && val <= 0x7e)
        {
            chan->Envelope_Enabled = true;
            ay_writeay(AY_ENV_SHAPE, val - 0x70);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern]);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_COARSE, module[chan->Address_In_Pattern]);
        }
        else if(val == 0x70)
            quit = true;
        else if(val >= 0x60 && val <= 0x6f)
        {
            chan->OrnamentPointer = PT2_OrnamentsPointers(val - 0x60);
            chan->Ornament_Length = module[chan->OrnamentPointer];
            chan->OrnamentPointer++;
            chan->Loop_Ornament_Position = module[chan->OrnamentPointer];
            chan->OrnamentPointer++;
            chan->Position_In_Ornament = 0;
        }
        else if(val >= 0x20 && val <= 0x5f)
		            chan->Number_Of_Notes_To_Skip = val - 0x20;
        else if(val >= 0x10 && val <= 0x1f)
            chan->Volume = val - 0x10;
        else if(val == 0xf)
        {
            chan->Address_In_Pattern++;
            PT2.Delay = module[chan->Address_In_Pattern];
        }
        else if(val == 0xe)
        {
            chan->Address_In_Pattern++;
            chan->Glissade = module[chan->Address_In_Pattern];
            chan->GlissType = 1;
            gliss = true;
        }
        else if(val == 0xd)
        {
            chan->Address_In_Pattern++;
            chan->Glissade = abs((signed char)(module[chan->Address_In_Pattern]));
            chan->Address_In_Pattern += 2; //Not use precalculated Ton_Delta
            //to avoide error with first note of pattern
            chan->GlissType = 2;
            gliss = true;
        }
        else if(val == 0xc)
            chan->GlissType = 0;
        else
        {
            chan->Address_In_Pattern++;
            chan->Addition_To_Noise = module[chan->Address_In_Pattern];
        }
        chan->Address_In_Pattern++;
    }
    while(!quit);
    if(gliss && (chan->GlissType == 2))
    {
        chan->Ton_Delta = abs(PT2_Table[chan->Slide_To_Note] - PT2_Table[chan->Note]);
        if(chan->Slide_To_Note > chan->Note)
            chan->Glissade = -chan->Glissade;
    }
    chan->Note_Skip_Counter = chan->Number_Of_Notes_To_Skip;
}

void PT2_GetRegisters(AYSongInfo * info, PT2_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char j, b0, b1;
    unsigned char *module = info->module;
    PT2_File *header = (PT2_File *)module;
	
    if(chan->Enabled)
    {
        b0 = module[chan->SamplePointer + chan->Position_In_Sample * 3];
        b1 = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 1];
        chan->Ton = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 2] + (unsigned short)((b1 & 15) << 8);
        if((b0 & 4) == 0)
            chan->Ton = -chan->Ton;
        j = chan->Note + module[chan->OrnamentPointer + chan->Position_In_Ornament];
        if(j > 95)
            j = 95;
        chan->Ton = (chan->Ton + chan->Current_Ton_Sliding + PT2_Table[j]) & 0xfff;
        if(chan->GlissType == 2)
        {
            chan->Ton_Delta = chan->Ton_Delta - abs(chan->Glissade);
            if(chan->Ton_Delta < 0)
            {
                chan->Note = chan->Slide_To_Note;
                chan->GlissType = 0;
                chan->Current_Ton_Sliding = 0;
            }
        }
        if(chan->GlissType != 0)
            chan->Current_Ton_Sliding += chan->Glissade;
        chan->Amplitude = (chan->Volume * 17 + (unsigned char)(chan->Volume > 7)) * (b1 >> 4) / 256;
        if(chan->Envelope_Enabled)
            chan->Amplitude = chan->Amplitude | 16;
        if((module[chan->SamplePointer + chan->Position_In_Sample * 3] & 1) != 0)
            *TempMixer = *TempMixer | 64;
        else
            ay_writeay(AY_NOISE_PERIOD, ((b0 >> 3) + chan->Addition_To_Noise) & 31);
        if((b0 & 2) != 0)
            *TempMixer = *TempMixer | 8;
        chan->Position_In_Sample++;
        if(chan->Position_In_Sample == chan->Sample_Length)
            chan->Position_In_Sample = chan->Loop_Sample_Position;
        chan->Position_In_Ornament++;
        if(chan->Position_In_Ornament == chan->Ornament_Length)
            chan->Position_In_Ornament = chan->Loop_Ornament_Position;
    }
    else
        chan->Amplitude = 0;
		
    *TempMixer = *TempMixer >> 1;
}

void PT2_Play(AYSongInfo * info)
{
    unsigned char TempMixer;
    unsigned char * module = info->module;
    PT2_File * header = (PT2_File *)module;
    PT2.DelayCounter--;
    if(PT2.DelayCounter == 0)
    {
        PT2_A.Note_Skip_Counter--;
        if(PT2_A.Note_Skip_Counter < 0)
        {
            if(module[PT2_A.Address_In_Pattern] == 0)
            {
                PT2.CurrentPosition++;
                if(PT2.CurrentPosition == PT2_NumberOfPositions)
                    PT2.CurrentPosition = PT2_LoopPosition;
                PT2_A.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer+ PT2_PositionList(PT2.CurrentPosition) * 6]);
                PT2_B.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer + PT2_PositionList(PT2.CurrentPosition) * 6 + 2]);
                PT2_C.Address_In_Pattern = ay_sys_getword(&module[PT2_PatternsPointer + PT2_PositionList(PT2.CurrentPosition) * 6 + 4]);
            }
            PT2_PatternInterpreter(info, &PT2_A);
        }
        PT2_B.Note_Skip_Counter--;
        if(PT2_B.Note_Skip_Counter < 0)
        PT2_PatternInterpreter(info, &PT2_B);
        PT2_C.Note_Skip_Counter--;
        if(PT2_C.Note_Skip_Counter < 0)
        PT2_PatternInterpreter(info, &PT2_C);
        PT2.DelayCounter = PT2.Delay;
    }

    TempMixer = 0;
    PT2_GetRegisters(info, &PT2_A, &TempMixer);
    PT2_GetRegisters(info, &PT2_B, &TempMixer);
    PT2_GetRegisters(info, &PT2_C, &TempMixer);

	///*
    ay_writeay(AY_MIXER, TempMixer);

    ay_writeay(AY_CHNL_A_FINE, PT2_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (PT2_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, PT2_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (PT2_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, PT2_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (PT2_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, PT2_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, PT2_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, PT2_C.Amplitude);
	//*/
}

void PT2_GetInfo(AYSongInfo * info)
{
    unsigned char *module = info->module;
    int a1, a2, a3, a11, a22, a33;
    unsigned long int j1, j2, j3;
    long i, tm = 0;
    unsigned char b;
    unsigned char ptDelay = module[0];
    unsigned char ptNumPos = module[1];
    unsigned int ptLoopPos = module[2];
    unsigned int ptPatPt = ay_sys_getword(&module[99]);
    const unsigned char *ptPosList = (unsigned char *)&module[131];

	
    b = ptDelay;
    a1 = a2 = a3 = a11 = a22 = a33 = 0;
    for(i = 0; i < ptNumPos; i++)
    {
        if(i == ptLoopPos)
        {
           // info->Loop = tm;
        }
        j1 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6]);
        j2 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6 + 2]);
        j3 = ay_sys_getword(&module[ptPatPt + ptPosList[i] * 6 + 4]);
        do
        {
            a1--;
            if(a1 < 0)
            {
                if(module[j1] == 0)
                    break;
                do
                {
                    unsigned char val = (unsigned char)module[j1];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a1 = a11;
                        j1++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j1 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a11 = module[j1] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j1++;
                        b = module[j1];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j1++;
                    }
                    else if(val == 0xd)
                    {
                        j1 += 3;
                    }
                    j1++;
                }
                while(true);
            }

            a2--;
            if(a2 < 0)
            {
                do
                {
                    unsigned char val = (unsigned char)module[j2];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a2 = a22;
                        j2++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j2 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a22 = module[j2] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j2++;
                        b = module[j2];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j2++;
                    }
                    else if(val == 0xd)
                    {
                        j2 += 3;
                    }
                    j2++;
                }
                while(true);
            }
            a3--;
            if(a3 < 0)
            {
                do
                {
                    unsigned char val = (unsigned char)module[j3];
                    if(val == 0x70 || (val >= 0x80 && val <= 0xe0))
                    {
                        a3 = a33;
                        j3++;
                        break;
                    }
                    else if(val >= 0x71 && val <= 0x7e)
                    {
                        j3 += 2;
                    }
                    else if(val >= 0x20 && val <= 0x5f)
                    {
                        a33 = module[j3] - 0x20;
                    }
                    else if(val == 0xf)
                    {
                        j3++;
                        b = module[j3];
                    }
                    else if((val >= 1 && val <= 0xb) || val == 0xe)
                    {
                        j3++;
                    }
                    else if(val == 0xd)
                    {
                        j3 += 3;
                    }
                    j3++;
                }
                while(true);
            }
            tm += b;
        }
        while(true);
    }
	
    info->len = tm;
    strncpy(info->Name, &module[101], 30);
    info->Autor[0]=0;
}






//======================== PT1 =============================

typedef struct
{
    unsigned char PT1_Delay;
    unsigned char PT1_NumberOfPositions;
    unsigned char PT1_LoopPosition;
    unsigned char PT1_SamplesPointers0[32]; //word
    unsigned char PT1_OrnamentsPointers0[32]; //word
    unsigned char PT1_PatternsPointer0, PT1_PatternsPointer1;
    signed char PT1_MusicName[30];
    unsigned char PT1_PositionList[65536 - 99];
} PT1_File;

#define PT1_SamplesPointers(x) (header->PT1_SamplesPointers0 [(x) * 2] | (header->PT1_SamplesPointers0 [(x) * 2 + 1] << 8))
#define PT1_OrnamentsPointers(x) (header->PT1_OrnamentsPointers0 [(x) * 2] | (header->PT1_OrnamentsPointers0 [(x) * 2 + 1] << 8))
#define PT1_PatternsPointer (header->PT1_PatternsPointer0 | (header->PT1_PatternsPointer1 << 8))

typedef struct 
{
    unsigned int Address_In_Pattern, OrnamentPointer, SamplePointer, Ton;
    unsigned char Number_Of_Notes_To_Skip, Volume, Loop_Sample_Position, Position_In_Sample, Sample_Length, Amplitude, Note;
    signed char Note_Skip_Counter;
    bool Envelope_Enabled, Enabled;
} PT1_Channel_Parameters;

typedef struct 
{
    unsigned char Delay, DelayCounter, CurrentPosition;
} PT1_Parameters;

typedef struct 
{
    PT1_Parameters PT1;
    PT1_Channel_Parameters PT1_A, PT1_B, PT1_C;
} PT1_SongInfo;

PT1_SongInfo PT1_SongInfoV;

#define PT1_A ((PT1_SongInfo *)info->data)->PT1_A
#define PT1_B ((PT1_SongInfo *)info->data)->PT1_B
#define PT1_C ((PT1_SongInfo *)info->data)->PT1_C
#define PT1 ((PT1_SongInfo *)info->data)->PT1

void PT1_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    
    PT1_File *header = (PT1_File *)module;
    
    info->data = (void *)& PT1_SongInfoV;
    
    
    memset(&PT1_A, 0, sizeof(PT1_Channel_Parameters));
    memset(&PT1_B, 0, sizeof(PT1_Channel_Parameters));
    memset(&PT1_C, 0, sizeof(PT1_Channel_Parameters));

    PT1.DelayCounter = 1;
    PT1.Delay = header->PT1_Delay;
    PT1.CurrentPosition = 0;
    PT1_A.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6]);
    PT1_B.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6 + 2]);
    PT1_C.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[0] * 6 + 4]);

    PT1_A.OrnamentPointer = PT1_OrnamentsPointers(0);
    PT1_A.Envelope_Enabled = false;
    PT1_A.Position_In_Sample = 0;
    PT1_A.Enabled = false;
    PT1_A.Number_Of_Notes_To_Skip = 0;
    PT1_A.Note_Skip_Counter = 0;
    PT1_A.Volume = 15;
    PT1_A.Ton = 0;

    PT1_B.OrnamentPointer = PT1_A.OrnamentPointer;
    PT1_B.Envelope_Enabled = false;
    PT1_B.Position_In_Sample = 0;
    PT1_B.Enabled = false;
    PT1_B.Number_Of_Notes_To_Skip = 0;
    PT1_B.Note_Skip_Counter = 0;
    PT1_B.Volume = 15;
    PT1_B.Ton = 0;

    PT1_C.OrnamentPointer = PT1_A.OrnamentPointer;
    PT1_C.Envelope_Enabled = false;
    PT1_C.Position_In_Sample = 0;
    PT1_C.Enabled = false;
    PT1_C.Number_Of_Notes_To_Skip = 0;
    PT1_C.Note_Skip_Counter = 0;
    PT1_C.Volume = 15;
    PT1_C.Ton = 0;

//    ay_resetay(&info, 0);
}

void PT1_PatternInterpreter(AYSongInfo * info, PT1_Channel_Parameters * chan)
{
    unsigned char *module = info->module;
    PT1_File *header = (PT1_File *)module;
    bool quit = false;
    do
    {
        unsigned char val = module[chan->Address_In_Pattern];
        if(val <= 0x5f)
        {
            chan->Note = val;
            chan->Enabled = true;
            chan->Position_In_Sample = 0;
            quit = true;
        }
        else if(val >= 0x60 && val <= 0x6f)
        {
            chan->SamplePointer = PT1_SamplesPointers(val - 0x60);
            chan->Sample_Length = module[chan->SamplePointer];
            chan->SamplePointer++;
            chan->Loop_Sample_Position = module[chan->SamplePointer];
            chan->SamplePointer++;
        }
        else if(val >= 0x70 && val <= 0x7f)
            chan->OrnamentPointer = PT1_OrnamentsPointers(val - 0x70);
        else if(val == 0x80)
        {
            chan->Enabled = false;
            quit = true;
        }
        else if(val == 0x81)
            chan->Envelope_Enabled = false;
        else if(val >= 0x82 && val <= 0x8f)
        {
            chan->Envelope_Enabled = true;
            ay_writeay(AY_ENV_SHAPE, val - 0x81);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern]);
            chan->Address_In_Pattern++;
            ay_writeay(AY_ENV_COARSE, module[chan->Address_In_Pattern]);
        }
        else if(val == 0x90)
            quit = true;
        else if(val >= 0x91 && val <= 0xa0)
            PT1.Delay = val - 0x91;
        else if(val >= 0xa1 && val <= 0xb0)
            chan->Volume = val - 0xa1;
        else
            chan->Number_Of_Notes_To_Skip = val - 0xb1;
        chan->Address_In_Pattern++;
    }
    while(!quit);
    chan->Note_Skip_Counter = chan->Number_Of_Notes_To_Skip;
}

void PT1_GetRegisters(AYSongInfo * info, PT1_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char *module = info->module;
    unsigned char j, b;
    if(chan->Enabled)
    {
        j = chan->Note + module[chan->OrnamentPointer + chan->Position_In_Sample];
        if(j > 95)
            j = 95;
        b = module[chan->SamplePointer + chan->Position_In_Sample * 3];
        chan->Ton = ((((unsigned short)(b)) << 4) & 0xf00) + module[chan->SamplePointer + chan->Position_In_Sample * 3 + 2];
        chan->Amplitude = (chan->Volume * 17 + (chan->Volume > 7 ? 1 : 0)) * (b & 15) / 256;
        b = module[chan->SamplePointer + chan->Position_In_Sample * 3 + 1];
        if((b & 32) == 0)
            chan->Ton = -chan->Ton;
        chan->Ton = (chan->Ton + PT2_Table[j] + (j == 46 ? 1 : 0)) & 0xfff;
        if(chan->Envelope_Enabled)
            chan->Amplitude |= 16;
        if((signed char)b < 0)
            *TempMixer = *TempMixer | 64;
        else
            ay_writeay(AY_NOISE_PERIOD, b & 31);
        if((b & 64) != 0)
            *TempMixer = *TempMixer | 8;
        chan->Position_In_Sample++;
        if(chan->Position_In_Sample == chan->Sample_Length)
            chan->Position_In_Sample = chan->Loop_Sample_Position;
    }
    else
        chan->Amplitude = 0;
    *TempMixer = *TempMixer >> 1;

}

void PT1_Play(AYSongInfo * info)
{
    unsigned char *module = info->module;
    PT1_File *header = (PT1_File *)module;
    unsigned char TempMixer;
    PT1.DelayCounter--;
    if(PT1.DelayCounter == 0)
    {
        PT1_A.Note_Skip_Counter--;
        if(PT1_A.Note_Skip_Counter < 0)
        {
            if(module[PT1_A.Address_In_Pattern] == 255)
            {
                PT1.CurrentPosition++;
                if(PT1.CurrentPosition == header->PT1_NumberOfPositions)
                    PT1.CurrentPosition = header->PT1_LoopPosition;
                PT1_A.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6]);
                PT1_B.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6 + 2]);
                PT1_C.Address_In_Pattern = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[PT1.CurrentPosition] * 6 + 4]);
            }
            PT1_PatternInterpreter(info, &PT1_A);
        }
        PT1_B.Note_Skip_Counter--;
        if(PT1_B.Note_Skip_Counter < 0)
            PT1_PatternInterpreter(info, &PT1_B);
        PT1_C.Note_Skip_Counter--;
        if(PT1_C.Note_Skip_Counter < 0)
            PT1_PatternInterpreter(info, &PT1_C);
        PT1.DelayCounter = PT1.Delay;
    }
    TempMixer = 0;
    PT1_GetRegisters(info, &PT1_A, &TempMixer);
    PT1_GetRegisters(info, &PT1_B, &TempMixer);
    PT1_GetRegisters(info, &PT1_C, &TempMixer);

    ay_writeay(AY_MIXER, TempMixer);

    ay_writeay(AY_CHNL_A_FINE, PT1_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (PT1_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, PT1_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (PT1_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, PT1_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (PT1_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, PT1_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, PT1_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, PT1_C.Amplitude);
}

void PT1_GetInfo(AYSongInfo * info)
{
    unsigned char * module = info->module;
    PT1_File *header = (PT1_File *)module;
    short a1, a2, a3, a11, a22, a33;
    unsigned long j1, j2, j3;
    long i, tm = 0;
    unsigned char b;
    unsigned char *ptr;
    
    
    b = header->PT1_Delay;
    a1 = a2 = a3 = a11 = a22 = a33 = 0;
    for(i = 0; i < header->PT1_NumberOfPositions; i++)
    {
        j1 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6]);
        j2 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6 + 2]);
        j3 = ay_sys_getword(&module[PT1_PatternsPointer + header->PT1_PositionList[i] * 6 + 4]);
        while(true)
        {
            a1--;
            if(a1 < 0)
            {

                if(module[j1] == 255)
                    break;
                while(true)
                {
                    unsigned char val = module[j1];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a1 = a11;
                        j1++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j1 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a11 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j1++;
                }
            }
            a2--;
            if(a2 < 0)
            {

                while(true)
                {
                    unsigned char val = module[j2];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a2 = a22;
                        j2++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j2 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a22 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j2++;
                }
            }
            a3--;
            if(a3 < 0)
            {

                while(true)
                {
                    unsigned char val = module[j3];
                    if(val == 0x80 || val == 0x90 || val <= 0x5f)
                    {
                        a3 = a33;
                        j3++;
                        break;
                    }
                    if(val >= 0x82 && val <= 0x8f)
                    {
                        j3 += 2;
                    }
                    if(val >= 0xb1 && val <= 0xfe)
                    {
                        a33 = val - 0xb1;
                    }
                    if(val >= 0x91 && val <= 0xa0)
                    {
                        b = val - 0x91;
                    }
                    j3++;
                }
            }
            tm += b;
        }
    }
    info->len = tm;
    ptr = module + 69;
    strncpy(info->Name, ptr, 30);
    info->Autor[0]=0;
}



bool PT1_Detect(unsigned char * module, unsigned int length, AYSongInfo * s)
{
    long j, j1, j2;
    long F_Length;
    
    PT1_File *header = (PT1_File *)module;
    if(length < 0x66)
        return false;
    if(PT1_PatternsPointer >= length)
        return false;

    j = 0;
    j1 = 65535;
    for(j2 = 0; j2 <= 15; j2++)
    {
        if(j < PT1_SamplesPointers(j2))
            j = PT1_SamplesPointers(j2);
        if((PT1_OrnamentsPointers(j2) != 0) && (j1 > PT1_OrnamentsPointers(j2)))
            j1 = PT1_OrnamentsPointers(j2);
    }

    if(j1 < 0x67)
        return false;
    if(j < 0x67)
        return false;
    if(j > 65534)
        return false;
    if(j > length)
        return false;
    if((j + module[j] * 3 + 2) != j1)
        return false;

    j = 0;
    for(j2 = 0; j2 <= 15; j2++)
        if(j < PT1_OrnamentsPointers(j2))
            j = PT1_OrnamentsPointers(j2);
    if(j < 0x67)
        return false;
    F_Length = j + 64;
    if(F_Length > 65536)
        return false;
    if(F_Length > length + 1)
        return false;

    j = 0x63;
    while((j <= PT1_PatternsPointer) && (module[j] != 255))
        j++;
    if(j + 1 != PT1_PatternsPointer)
        return false;

    header->PT1_NumberOfPositions = j - 0x63;
    
    strcpy(s->player, "Pro Tracker v1");
    
    return true;
}








const unsigned short ASM_Table1[] =
{ 0xedc, 0xe07, 0xd3e, 0xc80, 0xbcc, 0xb22, 0xa82, 0x9ec, 0x95c, 0x8d6, 0x858, 0x7e0, 0x76e, 0x704, 0x69f, 0x640, 0x5e6, 0x591, 0x541, 0x4f6, 0x4ae, 0x46b, 0x42c, 0x3f0, 0x3b7,
  0x382, 0x34f, 0x320, 0x2f3, 0x2c8, 0x2a1, 0x27b, 0x257, 0x236, 0x216, 0x1f8, 0x1dc, 0x1c1, 0x1a8, 0x190, 0x179, 0x164, 0x150, 0x13d, 0x12c, 0x11b, 0x10b, 0xfc, 0xee, 0xe0, 
  0xd4, 0xc8, 0xbd, 0xb2, 0xa8, 0x9f, 0x96, 0x8d, 0x85, 0x7e, 0x77, 0x70, 0x6a, 0x64, 0x5e, 0x59, 0x54, 0x50, 0x4b, 0x47, 0x43, 0x3f, 0x3c, 0x38, 0x35, 0x32, 0x2f, 0x2d, 0x2a, 
  0x28, 0x26, 0x24, 0x22, 0x20, 0x1e, 0x1c };

typedef struct 
{
    signed char PSC_MusicName[69];
    unsigned char PSC_UnknownPointer0, PSC_UnknownPointer1;
    unsigned char PSC_PatternsPointer0, PSC_PatternsPointer1;
    unsigned char PSC_Delay;
    unsigned char PSC_OrnamentsPointer0, PSC_OrnamentsPointer1;
    unsigned char PSC_SamplesPointers0[64];
} PSC_File;

#define PSC_UnknownPointer (header->PSC_UnknownPointer0 | (header->PSC_UnknownPointer1 << 8))
#define PSC_PatternsPointer (header->PSC_PatternsPointer0 | (header->PSC_PatternsPointer1 << 8))
#define PSC_OrnamentsPointer (header->PSC_OrnamentsPointer0 | (header->PSC_OrnamentsPointer1 << 8))
#define PSC_SamplesPointers(x) (header->PSC_SamplesPointers0 [(x) * 2] | ((header->PSC_SamplesPointers0 [((x) * 2) + 1]) << 8))

typedef struct 
{
    unsigned char num;
    unsigned int Address_In_Pattern, OrnamentPointer, SamplePointer, Ton;
    int Current_Ton_Sliding, Ton_Accumulator, Addition_To_Ton;
    signed char Initial_Volume, Note_Skip_Counter;
    unsigned char Note, Volume, Amplitude, Volume_Counter, Volume_Counter1, Volume_Counter_Init, Noise_Accumulator, Position_In_Sample, Loop_Sample_Position, Position_In_Ornament, Loop_Ornament_Position;
    bool Enabled, Ornament_Enabled, Envelope_Enabled, Gliss, Ton_Slide_Enabled, Break_Sample_Loop, Break_Ornament_Loop, Volume_Inc;
} PSC_Channel_Parameters;

typedef struct 
{
    unsigned char Delay, DelayCounter, Lines_Counter, Noise_Base;
    unsigned int Positions_Pointer;
} PSC_Parameters;

typedef struct 
{
    PSC_Parameters PSC;
    PSC_Channel_Parameters PSC_A, PSC_B, PSC_C;
} PSC_SongInfo;


PSC_SongInfo ppp;

#define PSC_A ((PSC_SongInfo *)info->data)->PSC_A
#define PSC_B ((PSC_SongInfo *)info->data)->PSC_B
#define PSC_C ((PSC_SongInfo *)info->data)->PSC_C
#define PSC ((PSC_SongInfo *)info->data)->PSC

void PSC_Init(AYSongInfo * info)
{
    unsigned char * module = info->module;
    PSC_File *header = (PSC_File *)module;
    
    info->data = (PSC_SongInfo *) &ppp;

    PSC.DelayCounter = 1;
    PSC.Delay = header->PSC_Delay;
    PSC.Positions_Pointer = PSC_PatternsPointer;
    PSC.Lines_Counter = 1;
    PSC.Noise_Base = 0;

    PSC_A.num = 0;
    PSC_B.num = 1;
    PSC_C.num = 2;

    PSC_A.SamplePointer = PSC_SamplesPointers(0) + 0x4c;
    PSC_B.SamplePointer = PSC_A.SamplePointer;
    PSC_C.SamplePointer = PSC_A.SamplePointer;
    PSC_A.OrnamentPointer = ay_sys_getword(&module[PSC_OrnamentsPointer]) + PSC_OrnamentsPointer;
    PSC_B.OrnamentPointer = PSC_A.OrnamentPointer;
    PSC_C.OrnamentPointer = PSC_A.OrnamentPointer;

    PSC_A.Break_Ornament_Loop = false;
    PSC_A.Ornament_Enabled = false;
    PSC_A.Enabled = false;
    PSC_A.Break_Sample_Loop = false;
    PSC_A.Ton_Slide_Enabled = false;
    PSC_A.Note_Skip_Counter = 1;
    PSC_A.Ton = 0;

    PSC_B.Break_Ornament_Loop = false;
    PSC_B.Ornament_Enabled = false;
    PSC_B.Enabled = false;
    PSC_B.Break_Sample_Loop = false;
    PSC_B.Ton_Slide_Enabled = false;
    PSC_B.Note_Skip_Counter = 1;
    PSC_B.Ton = 0;

    PSC_C.Break_Ornament_Loop = false;
    PSC_C.Ornament_Enabled = false;
    PSC_C.Enabled = false;
    PSC_C.Break_Sample_Loop = false;
    PSC_C.Ton_Slide_Enabled = false;
    PSC_C.Note_Skip_Counter = 1;
    PSC_C.Ton = 0;
}

void PSC_PatternInterpreter(AYSongInfo * info, PSC_Channel_Parameters * chan)
{
    unsigned char *module = info->module;
    PSC_File *header = (PSC_File *)module;
    bool quit;
    bool b1b, b2b, b3b, b4b, b5b, b6b, b7b;
    quit = b1b = b2b = b3b = b4b = b5b = b6b = b7b = false;
    do
    {
        unsigned char val = module[chan->Address_In_Pattern];
        if(val >= 0xc0)
        {
            chan->Note_Skip_Counter = val - 0xbf;
            quit = true;
        }
        else if(val >= 0xa0 && val <= 0xbf)
        {
            //chan->OrnamentPointer = (*(unsigned short *) &module[PSC_OrnamentsPointer + (val - 0xa0) * 2]) +PSC_OrnamentsPointer;
            chan->OrnamentPointer = ay_sys_getword(&module[PSC_OrnamentsPointer + (val - 0xa0) * 2]) + PSC_OrnamentsPointer;
        }
        else if(val >= 0x7e && val <= 0x9f)
        {
            if(val >= 0x80)
                chan->SamplePointer = PSC_SamplesPointers(val - 0x80) + 0x4c;
        }
        else if(val == 0x6b)
        {
            chan->Address_In_Pattern++;
            chan->Addition_To_Ton = module[chan->Address_In_Pattern];
            b5b = true;
        }
        else if(val == 0x6c)
        {
            chan->Address_In_Pattern++;
            chan->Addition_To_Ton = -(signed char)(module[chan->Address_In_Pattern]);
            b5b = true;
        }
        else if(val == 0x6d)
        {
            b4b = true;
            chan->Address_In_Pattern++;
            chan->Addition_To_Ton = module[chan->Address_In_Pattern];
        }
        else if(val == 0x6e)
        {
            chan->Address_In_Pattern++;
            PSC.Delay = module[chan->Address_In_Pattern];
        }
        else if(val == 0x6f)
        {
            b1b = true;
            chan->Address_In_Pattern++;
        }
        else if(val == 0x70)
        {
            b3b = true;
            chan->Address_In_Pattern++;
            chan->Volume_Counter1 = module[chan->Address_In_Pattern];
        }
        else if(val == 0x71)
        {
            chan->Break_Ornament_Loop = true;
            chan->Address_In_Pattern++;
        }
        else if(val == 0x7a)
        {
            chan->Address_In_Pattern++;
            if(chan->num == 1)
            {
                ay_writeay(AY_ENV_SHAPE, module[chan->Address_In_Pattern] & 15);
                ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern + 1]);
                ay_writeay(AY_ENV_COARSE, module[chan->Address_In_Pattern + 2]);
                chan->Address_In_Pattern += 2;
            }
        }
        else if(val == 0x7b)
        {
            chan->Address_In_Pattern++;
            if(chan->num == 1)
                PSC.Noise_Base = module[chan->Address_In_Pattern];
        }
        else if(val == 0x7c)
        {
            b1b = b3b = b4b = b5b = b6b = b7b = false;
            b2b = true;
        }
        else if(val == 0x7d)
        {
            chan->Break_Sample_Loop = true;
        }
        else if(val >= 0x58 && val <= 0x66)
        {
            chan->Initial_Volume = val - 0x57;
            chan->Envelope_Enabled = false;
            b6b = true;
        }
        else if(val == 0x57)
        {
            chan->Initial_Volume = 0xf;
            chan->Envelope_Enabled = true;
            b6b = true;
        }
        else if(val <= 0x56)
        {
            chan->Note = val;
            b6b = true;
            b7b = true;
        }
        else
            chan->Address_In_Pattern++;
        chan->Address_In_Pattern++;
    }
    while(!quit);

    if(b7b)
    {
        chan->Break_Ornament_Loop = false;
        chan->Ornament_Enabled = true;
        chan->Enabled = true;
        chan->Break_Sample_Loop = false;
        chan->Ton_Slide_Enabled = false;
        chan->Ton_Accumulator = 0;
        chan->Current_Ton_Sliding = 0;
        chan->Noise_Accumulator = 0;
        chan->Volume_Counter = 0;
        chan->Position_In_Sample = 0;
        chan->Position_In_Ornament = 0;
    }
    if(b6b)
        chan->Volume = chan->Initial_Volume;
    if(b5b)
    {
        chan->Gliss = false;
        chan->Ton_Slide_Enabled = true;
    }
    if(b4b)
    {
        chan->Current_Ton_Sliding = chan->Ton - ASM_Table1[chan->Note];
        chan->Gliss = true;
        if(chan->Current_Ton_Sliding >= 0)
            chan->Addition_To_Ton = -chan->Addition_To_Ton;
        chan->Ton_Slide_Enabled = true;
    }
    if(b3b)
    {
        chan->Volume_Counter = chan->Volume_Counter1;
        chan->Volume_Inc = true;
        if((chan->Volume_Counter & 0x40) != 0)
        {
            chan->Volume_Counter = -(signed char)(chan->Volume_Counter | 128);
            chan->Volume_Inc = false;
        }
        chan->Volume_Counter_Init = chan->Volume_Counter;
    }
    if(b2b)
    {
        chan->Break_Ornament_Loop = false;
        chan->Ornament_Enabled = false;
        chan->Enabled = false;
        chan->Break_Sample_Loop = false;
        chan->Ton_Slide_Enabled = false;
    }
    if(b1b)
        chan->Ornament_Enabled = false;
}

void PSC_GetRegisters(AYSongInfo * info, PSC_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char *module = info->module;
    unsigned char j, b;
    if(chan->Enabled)
    {
        j = chan->Note;
        if(chan->Ornament_Enabled)
        {
            b = module[chan->OrnamentPointer + chan->Position_In_Ornament * 2];
            chan->Noise_Accumulator += b;
            j += module[chan->OrnamentPointer + chan->Position_In_Ornament * 2 + 1];
            if((signed char)j < 0)
                j += 0x56;
            if(j > 0x55)
                j -= 0x56;
            if(j > 0x55)
                j = 0x55;
            if((b & 128) == 0)
                chan->Loop_Ornament_Position = chan->Position_In_Ornament;
            if((b & 64) == 0)
            {
                if(!chan->Break_Ornament_Loop)
                    chan->Position_In_Ornament = chan->Loop_Ornament_Position;
                else
                {
                    chan->Break_Ornament_Loop = false;
                    if((b & 32) == 0)
                        chan->Ornament_Enabled = false;
                    chan->Position_In_Ornament++;
                }
            }
            else
            {
                if((b & 32) == 0)
                    chan->Ornament_Enabled = false;
                chan->Position_In_Ornament++;
            }
        }
        chan->Note = j;
        //chan->Ton = *(unsigned short *) &module[chan->SamplePointer + chan->Position_In_Sample * 6];
        chan->Ton = ay_sys_getword(&module[chan->SamplePointer + chan->Position_In_Sample * 6]);
        chan->Ton_Accumulator += chan->Ton;
        chan->Ton = ASM_Table1[j] + chan->Ton_Accumulator;
        if(chan->Ton_Slide_Enabled)
        {
            chan->Current_Ton_Sliding += chan->Addition_To_Ton;
            if(chan->Gliss && (((chan->Current_Ton_Sliding < 0) && (chan->Addition_To_Ton <= 0)) || ((chan->Current_Ton_Sliding >= 0) && (chan->Addition_To_Ton >= 0))))
                chan->Ton_Slide_Enabled = false;
            chan->Ton += chan->Current_Ton_Sliding;
        }
        chan->Ton = chan->Ton & 0xfff;
        b = module[chan->SamplePointer + chan->Position_In_Sample * 6 + 4];
        *TempMixer = *TempMixer | ((b & 9) << 3);
        j = 0;
        if((b & 2) != 0)
            j++;
        if((b & 4) != 0)
            j--;
        if(chan->Volume_Counter > 0)
        {
            chan->Volume_Counter--;
            if(chan->Volume_Counter == 0)
            {
                if(chan->Volume_Inc)
                    j++;
                else
                    j--;
                chan->Volume_Counter = chan->Volume_Counter_Init;
            }
        }
        chan->Volume += j;
        if((signed char)chan->Volume < 0)
            chan->Volume = 0;
        else if(chan->Volume > 15)
            chan->Volume = 15;
        chan->Amplitude = ((chan->Volume + 1) * (module[chan->SamplePointer + chan->Position_In_Sample * 6 + 3] & 15)) >> 4;
        if(chan->Envelope_Enabled && ((b & 16) == 0))
            chan->Amplitude = chan->Amplitude | 16;
        if(((chan->Amplitude & 16) != 0) & ((b & 8) != 0))
        {
            unsigned short env = ay_readay(AY_ENV_FINE) | (ay_readay(AY_ENV_COARSE) << 8);
            env += (signed char)(module[chan->SamplePointer + chan->Position_In_Sample * 6 + 2]);
            ay_writeay(AY_ENV_FINE, env & 0xff);
            ay_writeay(AY_ENV_COARSE, (env >> 8) & 0xff);
        }
        else
        {
            chan->Noise_Accumulator += module[chan->SamplePointer + chan->Position_In_Sample * 6 + 2];
            if((b & 8) == 0)
                ay_writeay(AY_NOISE_PERIOD, chan->Noise_Accumulator & 31);
        }
        if((b & 128) == 0)
            chan->Loop_Sample_Position = chan->Position_In_Sample;
        if((b & 64) == 0)
        {
            if(!chan->Break_Sample_Loop)
                chan->Position_In_Sample = chan->Loop_Sample_Position;
            else
            {
                chan->Break_Sample_Loop = false;
                if((b & 32) == 0)
                    chan->Enabled = false;
                chan->Position_In_Sample++;
            }
        }
        else
        {
            if((b & 32) == 0)
                chan->Enabled = false;
            chan->Position_In_Sample++;
        }
    }
    else
        chan->Amplitude = 0;
    *TempMixer = *TempMixer >> 1;
}

void PSC_Play(AYSongInfo * info)
{
    unsigned char *module; 
    unsigned char TempMixer;

    //return;

    module = info->module;

    if(--PSC.DelayCounter <= 0)
    {
        if(--PSC.Lines_Counter <= 0)
        {
            if(module[PSC.Positions_Pointer + 1] == 255)
            {
                //PSC.Positions_Pointer = *(unsigned short *) &module[PSC.Positions_Pointer + 2];
                PSC.Positions_Pointer = ay_sys_getword(&module[PSC.Positions_Pointer + 2]);
            }
            PSC.Lines_Counter = module[PSC.Positions_Pointer + 1];
            //PSC_A.Address_In_Pattern = *(unsigned short *) &module[PSC.Positions_Pointer + 2];
            //PSC_B.Address_In_Pattern = *(unsigned short *) &module[PSC.Positions_Pointer + 4];
            //PSC_C.Address_In_Pattern = *(unsigned short *) &module[PSC.Positions_Pointer + 6];
            PSC_A.Address_In_Pattern = ay_sys_getword(&module[PSC.Positions_Pointer + 2]);
            PSC_B.Address_In_Pattern = ay_sys_getword(&module[PSC.Positions_Pointer + 4]);
            PSC_C.Address_In_Pattern = ay_sys_getword(&module[PSC.Positions_Pointer + 6]);
            PSC.Positions_Pointer += 8;
            PSC_A.Note_Skip_Counter = 1;
            PSC_B.Note_Skip_Counter = 1;
            PSC_C.Note_Skip_Counter = 1;
        }
        if(--PSC_A.Note_Skip_Counter == 0)
            PSC_PatternInterpreter(info, &PSC_A);
        if(--PSC_B.Note_Skip_Counter == 0)
            PSC_PatternInterpreter(info, &PSC_B);
        if(--PSC_C.Note_Skip_Counter == 0)
            PSC_PatternInterpreter(info, &PSC_C);
        PSC_A.Noise_Accumulator += PSC.Noise_Base;
        PSC_B.Noise_Accumulator += PSC.Noise_Base;
        PSC_C.Noise_Accumulator += PSC.Noise_Base;
        PSC.DelayCounter = PSC.Delay;
    }
    TempMixer = 0;
    PSC_GetRegisters(info, &PSC_A, &TempMixer);
    PSC_GetRegisters(info, &PSC_B, &TempMixer);
    PSC_GetRegisters(info, &PSC_C, &TempMixer);

    ay_writeay(AY_MIXER, TempMixer);
    ay_writeay(AY_CHNL_A_FINE, PSC_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (PSC_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, PSC_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (PSC_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, PSC_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (PSC_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, PSC_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, PSC_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, PSC_C.Amplitude);
}

void PSC_GetInfo(AYSongInfo * info)
{
    unsigned char *module = info->module;
    PSC_File *header = (PSC_File *)module;
    unsigned char b;
    unsigned long tm = 0;
    long i;
    char a1, a2, a3;
    unsigned long j1, j2, j3;
    unsigned long pptr, cptr;
    bool f71, f72, f73, f61, f62, f63, f41, f42, f43, flg;
    unsigned short j11, j22, j33;
    //unsigned char * ptr;
    
    f71 = f72 = f73 = f61 = f62 = f63 = f41 = f42 = f43 = flg = false;
    j11 = j22 = j33 = 0;
    
    b = header->PSC_Delay;
    pptr = PSC_PatternsPointer;
    pptr++;
    while(module[pptr] != 255)
    {
        pptr += 8;
        if(pptr >= 65536)
        {
            info->Length = 0;
            return;
        }
    }
    if(pptr >= 65546 - 2)
    {
        info->Length = 0;
    }
    //cptr = *(unsigned short *) &module[pptr + 1];
    cptr = ay_sys_getword(&module[pptr + 1]);
    cptr++;
    pptr = PSC_PatternsPointer;
    pptr++;
    while(module[pptr] != 255)
    {
       // if(pptr == cptr)
       //     info->Loop = tm;
            
        if(pptr >= 65536 - 6)
        {
            info->Length = 0;
            return;
        }
        //j1 = *(unsigned short *) &module[pptr + 1];
        //j2 = *(unsigned short *) &module[pptr + 3];
        //j3 = *(unsigned short *) &module[pptr + 5];
        j1 = ay_sys_getword(&module[pptr + 1]);
        j2 = ay_sys_getword(&module[pptr + 3]);
        j3 = ay_sys_getword(&module[pptr + 5]);
        pptr += 8;
        if(pptr >= 65536)
        {
            info->Length = 0;
            return;
        }
        a1 = a2 = a3 = 1;
        for(i = 0; i < module[pptr - 8]; i++)
        {
            a1--;
            if(a1 == 0)
            {
                while(true)
                {
                    unsigned char val = module[j1];
                    if(val >= 0xc0)
                    {
                        a1 = val - 0xbf;
                        j1++;
                        break;
                    }
                    else if((val >= 0x67 && val <= 0x6d) || (val >= 0x6f && val <= 0x7b))
                    {
                        j1++;
                    }
                    else if(val == 0x6e)
                    {
                        j1++;
                        b = module[j1];
                    }
                    j1++;
                }

            }

            a2--;
            if(a2 == 0)
            {
                while(true)
                {
                    unsigned char val = module[j2];
                    if(val >= 0xc0)
                    {
                        a2 = val - 0xbf;
                        j2++;
                        break;
                    }
                    else if((val >= 0x67 && val <= 0x6d) || (val >= 0x6f && val <= 0x7b))
                    {
                        j2++;
                    }
                    else if(val == 0x6e)
                    {
                        j2++;
                        b = module[j2];
                    }
                    j2++;
                }
            }

            a3--;
            if(a3 == 0)
            {
                while(true)
                {
                    unsigned char val = module[j3];
                    if(val >= 0xc0)
                    {
                        a3 = val - 0xbf;
                        j3++;
                        break;
                    }
                    else if((val >= 0x67 && val <= 0x6d) || (val >= 0x6f && val <= 0x7b))
                    {
                        j3++;
                    }
                    else if(val == 0x6e)
                    {
                        j3++;
                        b = module[j3];
                    }
                    j3++;
                }
            }
            tm += b;
        }
    }
    
    info->len = tm;
    //ptr = module + 0x19;
    
    //s->counter = (int)&module[0x10];
    
    strncpy(info->Name, &module[0x19], 20);
    strncpy(info->Autor, &module[0x31], 20);
    //ptr = module + 0x31;
    //info->Author = ay_sys_getstr(ptr, 20);
}

bool PSC_Detect(unsigned char * module, unsigned int length, AYSongInfo * s)
{
    unsigned int j, j1;
    PSC_File *header = (PSC_File *)module;
    
    
    
    
    //s->counter = 1001;
    
    if(length < 0x4c + 2)
        return false;
    
       //s->counter = 1002;
        
    if(PSC_OrnamentsPointer >= length)
        return false;
        
      // s->counter = 1003; 
     
    if(PSC_OrnamentsPointer < 0x4c + 2)
        return false;
      // s->counter = 1004;    
        
    if(PSC_OrnamentsPointer > 64 + 0x4c)
        return false;
        
      // s->counter = 1005;
        
    if((PSC_OrnamentsPointer % 2) != 0)
        return false;
        
       //s->counter = 1006;    
        
    if(PSC_SamplesPointers(0) + 0x4c + 5 > 65534)
        return false;
        
      // s->counter = 1007;    
        
    if(PSC_SamplesPointers(0) + 0x4c + 5 > length)
        return false;

       //s->counter = 1008;

    j = ay_sys_getword(&module[PSC_OrnamentsPointer]);
    j += PSC_OrnamentsPointer;
	
	//s->counter =j;
	
    //if(j > 65535)
    //    return false;
        
      // s->counter = 1009;    
        
    if(j >= length)
        return false;

    j1 = 0;
    j1 = ay_sys_getword(&module[PSC_OrnamentsPointer-2]);
    j1 += 0x4c;
 //  if(j1 > 65535)
  //      return false;
        
     // s->counter = 1010;    
        
    if(j1 >= length)
        return false;
        
      // s->counter = 1011;
           
    if(j - j1 < 8)
        return false;
        
      //s->counter = 1013;     
        
    if(((j - j1) % 6) != 2)
        return false;

    j1 = PSC_SamplesPointers(0) + 0x4c + 4;
    while(/*(j1 < 65536) &&*/ (j1 <= length) && ((module[j1] & 32) != 0))
        j1 += 6;
    if(j1 > 65534)
        return false;
        
      // s->counter = 1014;    
        
    if(j1 > length)
        return false;

    if(PSC_OrnamentsPointer - 0x4c - 2 > 0)
    {
        if(j1 + 3 != PSC_SamplesPointers(1) + 0x4c)
            return false;
    }
    
       
    
    else if(j1 + 4 != j)
    {
        s->counter = 1015;
        return false;
        }

      // s->counter = 1016;

    if(PSC_PatternsPointer + 11 > 65535)
        return false;
        
     // s->counter = 1017;     
        
    if(PSC_PatternsPointer + 11 >= length)
        return false;

       //s->counter = 1018;

    j = PSC_PatternsPointer + 1;
    if(module[j] == 255)
        return false;
        
    //  s->counter = 1019;

    while(1)
    {
        j += 8;
        if((j > 65532) && (j + 2 > length) || (module[j] == 255))
            break;
    }
    
    if(j > 65532)
        return false;
        
       //s->counter = 1020;    
        
    if(j + 2 > length)
        return false;

    //  s->counter = 1021;

    strcpy(s->player, "Pro Sound Creator");	

    return true;

}











////// LIB  //////



int abs(int value) 
{
  if (value < 0) 
  {
    return -value;
  }
  else 
  {
    return value;  
  }
}

int seed;

int rand(void)
{
  seed = ((7621 * seed + 1) /*% 32768*/);
  
  return abs (seed);
}


void Randomize(void)
{
  seed = get_r()*256;
}




void attr_new(char x, char y, char f, char t, char bright, char flash)
{
  int addr;
  unsigned char value=0;
  
  
  value+=f;
  value = value<<3;
  value+=t;
  
   if (bright)
    value |= 0x40;
  
  if (flash)
    value |= 0x80;
  
  addr = D_49152+6144+y*32+x;
  
  memset((void *)addr, value, 1);

}

void attr_old (unsigned int from, unsigned int len, char attr)
{
  unsigned int f;
  
  f=from+D_49152+6144;

  memset((void *)f, attr, len);
}

void ClearScreen(char * arg)
{	
    memset((void *)D_49152, 0, 6144);	
    
    gotoxy(0, 0);
    printf ("Shuffle Player %s", VERSION);
    
    
    attr_old(0, 32, WHITE);    
    attr_old(32, 32*4, BLUE*8+WHITE);
    attr_old(32*5, 32, WHITE);
    attr_old(32*6, 32*18, BLACK*8+WHITE+64);     
    
    gotoxy(2, 13);  
    printf(arg);
    gotoxy(0, 15);  
    printf("Additional controls: Space, P,");
    gotoxy(0, 16);  
    printf("Cursor keys,  Enter, Backspace.");
    
    attr_old(32*15, 32*2, BLACK*8+WHITE);  
}


typedef struct
{
 unsigned int SOURCE_POINTER;
 char mask;
 char buf;
 int r_r;
 unsigned int DECODER_BUFFER_POINTER;
 int addr ;
 char OUTPUT ;
 int NUM_B;
 char best_J;
 char best_I;
 char SSS;
        ///16b
} global;





global  *  g = (global *) 24339;


                            

void PSG_Init(AYSongInfo * info)
{
 unsigned char i;
 int F;
 int N; 
  
  //gotoxy(0, 5);
  //printf ("%d", sizeof(global));
 
  
  memset (g, 0 , sizeof(global)*14);
  
  for (i=0; i<14; i++)
  {
    memcpy (&g[i].SOURCE_POINTER, &info->module[6 + i*4], 2);   
    g[i].SOURCE_POINTER+=D_16384;
    
    memcpy (&g[i].best_I, &info->module[8 + i*4], 1); 
    memcpy (&g[i].best_J, &info->module[9 + i*4], 1); 
   
    F = ((1 << g[i].best_J) + 1);
    N = (1 << g[i].best_I);

    g[i].r_r = N - F;

    switch (g[i].best_I)
    {
      case 12:
       g[i].SSS = 15;
      break;
    
      case 11:
       g[i].SSS = 7;
      break;
       
      case 10:
       g[i].SSS = 3;
      break;
      
      case 9:
       g[i].SSS = 1;
      break;
      
      case 8:
       g[i].SSS = 0;
      break;
      
    }
   }
  
  /*
  for (i=0; i<=7; i++)
  {
    g[i].DECODER_BUFFER_POINTER = 49152 + i*2048;
    g[i+7].DECODER_BUFFER_POINTER = 49152 + i*2048; 
  }
  */
  
  
  for (i=6; i<=13; i++)
    g[i].DECODER_BUFFER_POINTER = 49152 + (i-6)*2048; 
  
  
  g[0].DECODER_BUFFER_POINTER = 49152;
  g[1].DECODER_BUFFER_POINTER = 51200;
  g[2].DECODER_BUFFER_POINTER = 53248;
  g[3].DECODER_BUFFER_POINTER = 57344;
  g[4].DECODER_BUFFER_POINTER = 59392;
  g[5].DECODER_BUFFER_POINTER = 63488;
  
  
}



