# include "all.h"




int pp = 0;
int offset;


const unsigned short ASM_Table[] =
{ 0xedc, 0xe07, 0xd3e, 0xc80, 0xbcc, 0xb22, 0xa82, 0x9ec, 0x95c, 0x8d6, 0x858, 0x7e0, 0x76e, 0x704, 0x69f, 0x640, 0x5e6, 0x591, 0x541, 0x4f6, 0x4ae, 0x46b, 0x42c, 0x3f0, 0x3b7,
  0x382, 0x34f, 0x320, 0x2f3, 0x2c8, 0x2a1, 0x27b, 0x257, 0x236, 0x216, 0x1f8, 0x1dc, 0x1c1, 0x1a8, 0x190, 0x179, 0x164, 0x150, 0x13d, 0x12c, 0x11b, 0x10b, 0xfc, 0xee, 0xe0, 
  0xd4, 0xc8, 0xbd, 0xb2, 0xa8, 0x9f, 0x96, 0x8d, 0x85, 0x7e, 0x77, 0x70, 0x6a, 0x64, 0x5e, 0x59, 0x54, 0x50, 0x4b, 0x47, 0x43, 0x3f, 0x3c, 0x38, 0x35, 0x32, 0x2f, 0x2d, 0x2a, 
  0x28, 0x26, 0x24, 0x22, 0x20, 0x1e, 0x1c };


/////////////////////////////////////////////////////
//////////////////////////////////////////////////////

typedef struct 
{
    unsigned char ASC0_Delay;
    unsigned char ASC0_PatternsPointers0, ASC0_PatternsPointers1;
    unsigned char ASC0_SamplesPointers0, ASC0_SamplesPointers1;
    unsigned char ASC0_OrnamentsPointers0, ASC0_OrnamentsPointers1;
    unsigned char ASC0_Number_Of_Positions;
    unsigned char ASC0_Positions[65536 - 8];
} ASC0_File;

typedef struct 
{
    unsigned char ASC1_Delay, ASC1_LoopingPosition;
    unsigned char ASC1_PatternsPointers0, ASC1_PatternsPointers1;
    unsigned char ASC1_SamplesPointers0, ASC1_SamplesPointers1;
    unsigned char ASC1_OrnamentsPointers0, ASC1_OrnamentsPointers1;
    unsigned char ASC1_Number_Of_Positions;
    unsigned char ASC1_Positions[65536 - 8];
} ASC1_File;

#define ASC1_PatternsPointers (header->ASC1_PatternsPointers0 | (header->ASC1_PatternsPointers1 << 8))
#define ASC1_SamplesPointers (header->ASC1_SamplesPointers0 | (header->ASC1_SamplesPointers1 << 8))
#define ASC1_OrnamentsPointers (header->ASC1_OrnamentsPointers0 | (header->ASC1_OrnamentsPointers1 << 8))

#define ASC0_PatternsPointers (header0->ASC0_PatternsPointers0 | (header0->ASC0_PatternsPointers1 << 8))
#define ASC0_SamplesPointers (header0->ASC0_SamplesPointers0 | (header0->ASC0_SamplesPointers1 << 8))
#define ASC0_OrnamentsPointers (header0->ASC0_OrnamentsPointers0 | (header0->ASC0_OrnamentsPointers1 << 8))


typedef struct 
{
    unsigned short Initial_Point_In_Sample, Point_In_Sample, Loop_Point_In_Sample, Initial_Point_In_Ornament, Point_In_Ornament, Loop_Point_In_Ornament, Address_In_Pattern, Ton, Ton_Deviation;
    unsigned char Note, Addition_To_Note, Number_Of_Notes_To_Skip, Initial_Noise, Current_Noise, Volume, Ton_Sliding_Counter, Amplitude, Amplitude_Delay, Amplitude_Delay_Counter;
    short Current_Ton_Sliding, Substruction_for_Ton_Sliding;
    signed char Note_Skip_Counter, Addition_To_Amplitude;
    bool Envelope_Enabled, Sound_Enabled, Sample_Finished, Break_Sample_Loop, Break_Ornament_Loop;
} ASC_Channel_Parameters;

typedef struct 
{
    unsigned char Delay, DelayCounter, CurrentPosition;
} ASC_Parameters;

typedef struct 
{
    ASC_Parameters ASC;
    ASC_Channel_Parameters ASC_A, ASC_B, ASC_C;
} ASC_SongInfo;

ASC_SongInfo asc;

#define ASC_A ((ASC_SongInfo *)info->data)->ASC_A
#define ASC_B ((ASC_SongInfo *)info->data)->ASC_B
#define ASC_C ((ASC_SongInfo *)info->data)->ASC_C
#define ASC ((ASC_SongInfo *)info->data)->ASC

#define GET_ADDRINPATT(x,y) ((module[ascPatPt + 6 * module[x + 9] + y * 2] | (module[ascPatPt + 6 * module[x + 9] + 1 + y * 2] << 8))  + ascPatPt)


void ASC_Init_orig(AYSongInfo * info)
{
    unsigned char *module = info->module;
    ASC1_File *header = (ASC1_File *)module;
    unsigned short ascPatPt = ASC1_PatternsPointers;
    
    info->data = &asc;
   
    memset(&ASC_A, 0, sizeof(ASC_Channel_Parameters));
    memset(&ASC_B, 0, sizeof(ASC_Channel_Parameters));
    memset(&ASC_C, 0, sizeof(ASC_Channel_Parameters));
    
    ASC.CurrentPosition = 0;
    ASC.DelayCounter = 1;
    ASC.Delay = header->ASC1_Delay;
    ASC_A.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[9]]) + ascPatPt;
    ASC_B.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[9] + 2]) + ascPatPt;
    ASC_C.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[9] + 4]) + ascPatPt;
}


void AS0_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    ASC0_File *header0 = (ASC0_File *)module;
    unsigned short ascPatPt = ASC0_PatternsPointers;
    
 
    info->data = &asc;
   
    memset(&ASC_A, 0, sizeof(ASC_Channel_Parameters));
    memset(&ASC_B, 0, sizeof(ASC_Channel_Parameters));
    memset(&ASC_C, 0, sizeof(ASC_Channel_Parameters));
    ASC.CurrentPosition = 0;
    ASC.DelayCounter = 1;
    ASC.Delay = header0->ASC0_Delay;
    ASC_A.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[8]]) + ascPatPt;
    ASC_B.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[8] + 2]) + ascPatPt;
    ASC_C.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[8] + 4]) + ascPatPt;
}

void ASC_Init(AYSongInfo * info)
{
 
  	    if (pp==3)
	    AS0_Init(info);		  
	    else	
	    ASC_Init_orig(info);		   
}


void ASC_PatternInterpreter(AYSongInfo * info, ASC_Channel_Parameters * chan, int AS0)
{
    unsigned char *module = info->module;
    
    ASC1_File *header = (ASC1_File *)module;
    ASC0_File *header0 = (ASC0_File *)module;
    
    short delta_ton;
    bool Initialization_Of_Ornament_Disabled, Initialization_Of_Sample_Disabled;

    Initialization_Of_Ornament_Disabled = Initialization_Of_Sample_Disabled = false;

    chan->Ton_Sliding_Counter = 0;
    chan->Amplitude_Delay_Counter = 0;
    while(true)
    {
        unsigned char val = module[chan->Address_In_Pattern];
        if(val <= 0x55)
        {
            chan->Note = val;
            chan->Address_In_Pattern++;
            chan->Current_Noise = chan->Initial_Noise;
            if((signed char)(chan->Ton_Sliding_Counter) <= 0)
                chan->Current_Ton_Sliding = 0;
            if(!Initialization_Of_Sample_Disabled)
            {
                chan->Addition_To_Amplitude = 0;
                chan->Ton_Deviation = 0;
                chan->Point_In_Sample = chan->Initial_Point_In_Sample;
                chan->Sound_Enabled = true;
                chan->Sample_Finished = false;
                chan->Break_Sample_Loop = false;
            }
            if(!Initialization_Of_Ornament_Disabled)
            {
                chan->Point_In_Ornament = chan->Initial_Point_In_Ornament;
                chan->Addition_To_Note = 0;
            }
            if(chan->Envelope_Enabled)
            {
                ay_writeay(AY_ENV_FINE, module[chan->Address_In_Pattern]);
                chan->Address_In_Pattern++;
            }
            break;
        }
        else if((val >= 0x56) && (val <= 0x5d))
        {
            chan->Address_In_Pattern++;
            break;
        }
        else if(val == 0x5e)
        {
            chan->Break_Sample_Loop = true;
            chan->Address_In_Pattern++;
            break;
        }
        else if(val == 0x5f)
        {
            chan->Sound_Enabled = false;
            chan->Address_In_Pattern++;
            break;
        }
        else if((val >= 0x60) && (val <= 0x9f))
        {
            chan->Number_Of_Notes_To_Skip = val - 0x60;
        }
        else if((val >= 0xa0) && (val <= 0xbf))
        {
            if (!AS0)
            chan->Initial_Point_In_Sample = ay_sys_getword(&module[(module[chan->Address_In_Pattern] - 0xa0) * 2 + ASC1_SamplesPointers]) + ASC1_SamplesPointers;
            else
            chan->Initial_Point_In_Sample = ay_sys_getword(&module[(module[chan->Address_In_Pattern] - 0xa0) * 2 + ASC0_SamplesPointers]) + ASC0_SamplesPointers;
            
        }
        else if((val >= 0xc0) && (val <= 0xdf))
        {
            if (!AS0)
            chan->Initial_Point_In_Ornament = ay_sys_getword(&module[(module[chan->Address_In_Pattern] - 0xc0) * 2 + ASC1_OrnamentsPointers]) + ASC1_OrnamentsPointers;
            else
            chan->Initial_Point_In_Ornament = ay_sys_getword(&module[(module[chan->Address_In_Pattern] - 0xc0) * 2 + ASC0_OrnamentsPointers]) + ASC0_OrnamentsPointers;
           
        }
        else if(val == 0xe0)
        {
            chan->Volume = 15;
            chan->Envelope_Enabled = true;
        }
        else if((val >= 0xe1) && (val <= 0xef))
        {
            chan->Volume = val - 0xe0;
            chan->Envelope_Enabled = false;
        }
        else if(val == 0xf0)
        {
            chan->Address_In_Pattern++;
            chan->Initial_Noise = module[chan->Address_In_Pattern];
        }
        else if(val == 0xf1)
        {
            Initialization_Of_Sample_Disabled = true;
        }
        else if(val == 0xf2)
        {
            Initialization_Of_Ornament_Disabled = true;
        }
        else if(val == 0xf3)
        {
            Initialization_Of_Sample_Disabled = true;
            Initialization_Of_Ornament_Disabled = true;
        }
        else if(val == 0xf4)
        {
            chan->Address_In_Pattern++;
            ASC.Delay = module[chan->Address_In_Pattern];
        }
        else if(val == 0xf5)
        {
            chan->Address_In_Pattern++;
            chan->Substruction_for_Ton_Sliding = -(signed char)(module[chan->Address_In_Pattern]) * 16;
            chan->Ton_Sliding_Counter = 255;
        }
        else if(val == 0xf6)
        {
            chan->Address_In_Pattern++;
            chan->Substruction_for_Ton_Sliding = (signed char)(module[chan->Address_In_Pattern]) * 16;
            chan->Ton_Sliding_Counter = 255;
        }
        else if(val == 0xf7)
        {
            chan->Address_In_Pattern++;
            Initialization_Of_Sample_Disabled = true;
            if(module[chan->Address_In_Pattern + 1] < 0x56)
                delta_ton = ASM_Table[chan->Note] + (chan->Current_Ton_Sliding / 16) - ASM_Table[module[chan->Address_In_Pattern + 1]];
            else
                delta_ton = chan->Current_Ton_Sliding / 16;
            delta_ton = delta_ton << 4;
            chan->Substruction_for_Ton_Sliding = -delta_ton / (signed char)(module[chan->Address_In_Pattern]);
            chan->Current_Ton_Sliding = delta_ton - delta_ton % (signed char)(module[chan->Address_In_Pattern]);
            chan->Ton_Sliding_Counter = (signed char)(module[chan->Address_In_Pattern]);
        }
        else if(val == 0xf8)
        {
            ay_writeay(AY_ENV_SHAPE, 8);
        }
        else if(val == 0xf9)
        {
            chan->Address_In_Pattern++;
            if(module[chan->Address_In_Pattern + 1] < 0x56)
            {
                delta_ton = ASM_Table[chan->Note] - ASM_Table[module[chan->Address_In_Pattern + 1]];
            }
            else
                delta_ton = chan->Current_Ton_Sliding / 16;
            delta_ton = delta_ton << 4;
            chan->Substruction_for_Ton_Sliding = -delta_ton / (signed char)(module[chan->Address_In_Pattern]);
            chan->Current_Ton_Sliding = delta_ton - delta_ton % (signed char)(module[chan->Address_In_Pattern]);
            chan->Ton_Sliding_Counter = (signed char)(module[chan->Address_In_Pattern]);

        }
        else if(val == 0xfa)
        {
            ay_writeay(AY_ENV_SHAPE, 10);
        }
        else if(val == 0xfb)
        {
            chan->Address_In_Pattern++;
            if((module[chan->Address_In_Pattern] & 32) == 0)
            {
                chan->Amplitude_Delay = module[chan->Address_In_Pattern] << 3;
                chan->Amplitude_Delay_Counter = chan->Amplitude_Delay;
            }
            else
            {
                chan->Amplitude_Delay = ((module[chan->Address_In_Pattern] << 3) ^ 0xf8) + 9;
                chan->Amplitude_Delay_Counter = chan->Amplitude_Delay;
            }
        }
        else if(val == 0xfc)
        {
            ay_writeay(AY_ENV_SHAPE, 12);
        }
        else if(val == 0xfe)
        {
            ay_writeay(AY_ENV_SHAPE, 14);
        }
        chan->Address_In_Pattern++;
    }
    chan->Note_Skip_Counter = chan->Number_Of_Notes_To_Skip;
}

void ASC_GetRegisters(AYSongInfo * info, ASC_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char *module = info->module;
    signed char j;
    bool Sample_Says_OK_for_Envelope;
    if(chan->Sample_Finished || !chan->Sound_Enabled)
        chan->Amplitude = 0;
    else
    {
        if(chan->Amplitude_Delay_Counter != 0)
        {
            if(chan->Amplitude_Delay_Counter >= 16)
            {
                chan->Amplitude_Delay_Counter -= 8;
                if(chan->Addition_To_Amplitude < -15)
                    chan->Addition_To_Amplitude++;
                else if(chan->Addition_To_Amplitude > 15)
                    chan->Addition_To_Amplitude--;
            }
            else
            {
                if((chan->Amplitude_Delay_Counter & 1) != 0)
                {
                    if(chan->Addition_To_Amplitude > -15)
                        chan->Addition_To_Amplitude--;
                }
                else if(chan->Addition_To_Amplitude < 15)
                    chan->Addition_To_Amplitude++;
                chan->Amplitude_Delay_Counter = chan->Amplitude_Delay;
            }
        }
        if((module[chan->Point_In_Sample] & 128) != 0)
            chan->Loop_Point_In_Sample = chan->Point_In_Sample;
        if((module[chan->Point_In_Sample] & 96) == 32)
            chan->Sample_Finished = true;
        chan->Ton_Deviation += (signed char)(module[chan->Point_In_Sample + 1]);
        *TempMixer |= (module[chan->Point_In_Sample + 2] & 9) << 3;
        if((module[chan->Point_In_Sample + 2] & 6) == 2)
            Sample_Says_OK_for_Envelope = true;
        else
            Sample_Says_OK_for_Envelope = false;
        if((module[chan->Point_In_Sample + 2] & 6) == 4)
        {
            if(chan->Addition_To_Amplitude > -15)
                chan->Addition_To_Amplitude--;
        }
        if((module[chan->Point_In_Sample + 2] & 6) == 6)
        {
            if(chan->Addition_To_Amplitude < 15)
                chan->Addition_To_Amplitude++;
        }
        chan->Amplitude = chan->Addition_To_Amplitude + (module[chan->Point_In_Sample + 2] >> 4);
        if((signed char)(chan->Amplitude) < 0)
            chan->Amplitude = 0;
        else if(chan->Amplitude > 15)
            chan->Amplitude = 15;
        chan->Amplitude = (chan->Amplitude * (chan->Volume + 1)) >> 4;
        if(Sample_Says_OK_for_Envelope && ((*TempMixer & 64) != 0))
            ay_writeay(AY_ENV_FINE, ay_readay(AY_ENV_FINE) + ((signed char)(module[chan->Point_In_Sample] << 3) / 8));
        else
            chan->Current_Noise += (signed char)(module[chan->Point_In_Sample] << 3) / 8;
        chan->Point_In_Sample += 3;
        if((module[chan->Point_In_Sample - 3] & 64) != 0)
        {
            if(!chan->Break_Sample_Loop)
                chan->Point_In_Sample = chan->Loop_Point_In_Sample;
            else if((module[chan->Point_In_Sample - 3] & 32) != 0)
                chan->Sample_Finished = true;
        }
        if((module[chan->Point_In_Ornament] & 128) != 0)
            chan->Loop_Point_In_Ornament = chan->Point_In_Ornament;
        chan->Addition_To_Note += module[chan->Point_In_Ornament + 1];
        chan->Current_Noise += (-(signed char)(module[chan->Point_In_Ornament] & 0x10)) | module[chan->Point_In_Ornament];
        chan->Point_In_Ornament += 2;
        if((module[chan->Point_In_Ornament - 2] & 64) != 0)
            chan->Point_In_Ornament = chan->Loop_Point_In_Ornament;
        if((*TempMixer & 64) == 0)
            ay_writeay(AY_NOISE_PERIOD, ((unsigned char)(chan->Current_Ton_Sliding >> 8) + chan->Current_Noise) & 0x1f);
        j = chan->Note + chan->Addition_To_Note;
        if(j < 0)
            j = 0;
        else if(j > 0x55)
            j = 0x55;
        chan->Ton = (ASM_Table[j] + chan->Ton_Deviation + (chan->Current_Ton_Sliding / 16)) & 0xfff;
        if(chan->Ton_Sliding_Counter != 0)
        {
            if((signed char)(chan->Ton_Sliding_Counter) > 0)
                chan->Ton_Sliding_Counter--;
            chan->Current_Ton_Sliding += chan->Substruction_for_Ton_Sliding;
        }
        if(chan->Envelope_Enabled && Sample_Says_OK_for_Envelope)
            chan->Amplitude |= 0x10;
    }
    *TempMixer = *TempMixer >> 1;
}

void ASC_Play_orig(AYSongInfo *info)
{
    unsigned short ascPatPt ;
    unsigned char *module = info->module;
    ASC1_File *header = (ASC1_File *)module;
    unsigned char TempMixer;

    if(--ASC.DelayCounter <= 0)
    {
        if(--ASC_A.Note_Skip_Counter < 0)
        {
            if(module[ASC_A.Address_In_Pattern] == 255)
            {
                if(++ASC.CurrentPosition >= header->ASC1_Number_Of_Positions)
                    ASC.CurrentPosition = header->ASC1_LoopingPosition;
                ascPatPt = ASC1_PatternsPointers;
                //ASC_A.Address_In_Pattern = (*(unsigned short *)&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9]]) + ascPatPt;
                //ASC_B.Address_In_Pattern = (*(unsigned short *)&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9] + 2]) + ascPatPt;
                //ASC_C.Address_In_Pattern = (*(unsigned short *)&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9] + 4]) + ascPatPt;
                ASC_A.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9]]) + ascPatPt;
                ASC_B.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9] + 2]) + ascPatPt;
                ASC_C.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 9] + 4]) + ascPatPt;
                ASC_A.Initial_Noise = 0;
                ASC_B.Initial_Noise = 0;
                ASC_C.Initial_Noise = 0;
            }
            ASC_PatternInterpreter(info, &ASC_A, 0);
        }
        if(--ASC_B.Note_Skip_Counter < 0)
        {
            ASC_PatternInterpreter(info, &ASC_B, 0);
        }
        if(--ASC_C.Note_Skip_Counter < 0)
        {
            ASC_PatternInterpreter(info, &ASC_C, 0);
        }
        ASC.DelayCounter = ASC.Delay;
    }

    TempMixer = 0;
    ASC_GetRegisters(info, &ASC_A, &TempMixer);
    ASC_GetRegisters(info, &ASC_B, &TempMixer);
    ASC_GetRegisters(info, &ASC_C, &TempMixer);

    ay_writeay(AY_MIXER, TempMixer);
    ay_writeay(AY_CHNL_A_FINE, ASC_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (ASC_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, ASC_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (ASC_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, ASC_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (ASC_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, ASC_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, ASC_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, ASC_C.Amplitude);
}


void AS0_Play(AYSongInfo *info)
{
    unsigned short ascPatPt ;
    unsigned char *module = info->module;
    ASC0_File *header0 = (ASC0_File *)module;
    unsigned char TempMixer;

    if(--ASC.DelayCounter <= 0)
    {
        if(--ASC_A.Note_Skip_Counter < 0)
        {
            if(module[ASC_A.Address_In_Pattern] == 255)
            {
                if(++ASC.CurrentPosition >= header0->ASC0_Number_Of_Positions)
                    ASC.CurrentPosition = 0;
                ascPatPt = ASC0_PatternsPointers;
 
                ASC_A.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 8]]) + ascPatPt;
                ASC_B.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 8] + 2]) + ascPatPt;
                ASC_C.Address_In_Pattern = ay_sys_getword(&module[ascPatPt + 6 * module[ASC.CurrentPosition + 8] + 4]) + ascPatPt;
                ASC_A.Initial_Noise = 0;
                ASC_B.Initial_Noise = 0;
                ASC_C.Initial_Noise = 0;
            }
            ASC_PatternInterpreter(info, &ASC_A, 1);
        }
        if(--ASC_B.Note_Skip_Counter < 0)
        {
            ASC_PatternInterpreter(info, &ASC_B, 1);
        }
        if(--ASC_C.Note_Skip_Counter < 0)
        {
            ASC_PatternInterpreter(info, &ASC_C, 1);
        }
        ASC.DelayCounter = ASC.Delay;
    }

    TempMixer = 0;
    ASC_GetRegisters(info, &ASC_A, &TempMixer);
    ASC_GetRegisters(info, &ASC_B, &TempMixer);
    ASC_GetRegisters(info, &ASC_C, &TempMixer);

    ay_writeay(AY_MIXER, TempMixer);
    ay_writeay(AY_CHNL_A_FINE, ASC_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (ASC_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, ASC_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (ASC_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, ASC_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (ASC_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, ASC_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, ASC_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, ASC_C.Amplitude);
}

void ASC_Play(AYSongInfo *info)
{
  
     if (pp==3)
	  AS0_Play(info);
     else	  
	  ASC_Play_orig(info);	
	  
}

void ASC_GetInfo_orig(AYSongInfo * info, int ASC0)
{
    unsigned short pp;
    unsigned char np;
    short a1, a2, a3, a11, a22, a33;
    unsigned long j1, j2, j3;
    bool env1, env2, env3;
    long i, tm = 0;
    unsigned char b;
    unsigned char ascNumPos;
    unsigned short ascPatPt;
    unsigned char ascDelay;
    unsigned short ascLoopPos;

    unsigned char *module = info->module;
    ASC1_File *header = (ASC1_File *)module;
    ASC0_File *header0 = (ASC0_File *)module;
 
    
    if (!ASC0)
    {
    ascDelay = header->ASC1_Delay;
    ascLoopPos = header->ASC1_LoopingPosition;
    ascPatPt = ASC1_PatternsPointers;
    ascNumPos = header->ASC1_Number_Of_Positions;
    }
    else
    {
    ascDelay = header0->ASC0_Delay;
    ascLoopPos = 0;
    ascPatPt = ASC0_PatternsPointers;
    ascNumPos = header0->ASC0_Number_Of_Positions;
     }
       
    

    b = ascDelay;
    a1 = a2 = a3 = a11 = a22 = a33 = 0;
    env1 = env2 = env3 = false;
    for(i = 0; i < ascNumPos; i++)
    {
       // if(ascLoopPos == i)
         //   info->Loop = tm;
   
        if (ASC0)
        {  
        j1 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 8]]) + ascPatPt;
        j2 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 8] + 2]) + ascPatPt;
        j3 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 8] + 4]) + ascPatPt;
        }
        else
        {  
        j1 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 9]]) + ascPatPt;
        j2 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 9] + 2]) + ascPatPt;
        j3 = ay_sys_getword(&module[ascPatPt + 6 * module[i + 9] + 4]) + ascPatPt;
        }
       
         
         while(true)
        {
            a1--;
            if(a1 < 0)
            {
                if(module[j1] == 255)
                    break;
                while(true)
                {
                    unsigned char val = module[j1];
                    if(val <= 0x55)
                    {
                        a1 = a11;
                        j1++;
                        if(env1)
                            j1++;
                        break;
                    }
                    else if((val >= 0x56) && (val <= 0x5f))
                    {
                        a1 = a11;
                        j1++;
                        break;
                    }
                    else if((val >= 0x60) && (val <= 0x9f))
                    {
                        a11 = val - 0x60;
                    }
                    else if(val == 0xe0)
                    {
                        env1 = true;
                    }
                    else if((val >= 0xe1) && (val <= 0xef))
                    {
                        env1 = false;
                    }
                    else if((val == 0xf0) || ((val >= 0xf5) && (val <= 0xf7)) || (val == 0xf9) || (val == 0xfb))
                    {
                        j1++;
                    }
                    else if(val == 0xf4)
                    {
                        j1++;
                        b = module[j1];
                    }
                    j1++;
                }
            }

            a2--;
            if(a2 < 0)
            {
                while(true)
                {
                    unsigned char val = module[j2];
                    if(val <= 0x55)
                    {
                        a2 = a22;
                        j2++;
                        if(env2)
                            j2++;
                        break;
                    }
                    else if((val >= 0x56) && (val <= 0x5f))
                    {
                        a2 = a22;
                        j2++;
                        break;
                    }
                    else if((val >= 0x60) && (val <= 0x9f))
                    {
                        a22 = val - 0x60;
                    }
                    else if(val == 0xe0)
                    {
                        env2 = true;
                    }
                    else if((val >= 0xe1) && (val <= 0xef))
                    {
                        env2 = false;
                    }
                    else if((val == 0xf0) || ((val >= 0xf5) && (val <= 0xf7)) || (val == 0xf9) || (val == 0xfb))
                    {
                        j2++;
                    }
                    else if(val == 0xf4)
                    {
                        j2++;
                        b = module[j2];
                    }
                    j2++;
                }
            }

            a3--;
            if(a3 < 0)
            {
                while(true)
                {
                    unsigned char val = (unsigned char)module[j3];
                    if(val <= 0x55)
                    {
                        a3 = a33;
                        j3++;
                        if(env3)
                            j3++;
                        break;
                    }
                    else if((val >= 0x56) && (val <= 0x5f))
                    {
                        a3 = a33;
                        j3++;
                        break;
                    }
                    else if((val >= 0x60) && (val <= 0x9f))
                    {
                        a33 = val - 0x60;
                    }
                    else if(val == 0xe0)
                    {
                        env3 = true;
                    }
                    else if((val >= 0xe1) && (val <= 0xef))
                    {
                        env3 = false;
                    }
                    else if((val == 0xf0) || ((val >= 0xf5) && (val <= 0xf7)) || (val == 0xf9) || (val == 0xfb))
                    {
                        j3++;
                    }
                    else if(val == 0xf4)
                    {
                        j3++;
                        b = module[j3];
                    }
                    j3++;
                }
            }
            tm += b;
        }
    }
    
    info->len = tm;
    
    pp = ay_sys_getword(&module [2]);
    np = module [8];
    if((pp - np) == 72)
    {
        strncpy(info->Name, &module [pp - 44], 20);
        strncpy(info->Autor,&module [pp - 20], 20);
    }
}

void ASC_GetInfo(AYSongInfo * info)
{


if (pp==3)   
	    ASC_GetInfo_orig(info, 1);
	    else
	    ASC_GetInfo_orig(info, 0);
	   
}
	    

bool ASC1_Detect(unsigned char *module, unsigned long length)
{
    int j, j1;
    unsigned char j3;
    int delta;
    ASC1_File *header = (ASC1_File *)module;
    
         
   
    if(length < 9)
        return false;
    delta = ASC1_PatternsPointers - header->ASC1_Number_Of_Positions;
    if(delta < 9 || delta > 72)
        return false;
    if(ASC1_PatternsPointers> length)
        return false;
    if(ASC1_SamplesPointers> length)
        return false;
    if(ASC1_OrnamentsPointers> length)
        return false;

  

    j = ay_sys_getword(&module[ASC1_SamplesPointers]);
    if(j != 0x40)
        return false;
    j = ay_sys_getword(&module[ASC1_OrnamentsPointers]);
    if(j != 0x40)
        return false;

  

    j3 = 0;
    for(j1 = 0; j1 < header->ASC1_Number_Of_Positions; j1++)
        if(j3 < header->ASC1_Positions[j1])
            j3 = header->ASC1_Positions[j1];

    j = ay_sys_getword(&module[ASC1_PatternsPointers]);
    if(j != (j3 + 1) * 6)
        return false;
        
  
        
    j = ay_sys_getword(&module[ASC1_OrnamentsPointers + 0x40 - 2]);
    j += ASC1_OrnamentsPointers;
    while((j < length) && (j < 65535) && ((module[j] & 0x40) == 0))
        j += 2;

    if(j > 65534)
        return false;    
        
    if(j >= (length+512))
        return false;
        
        
    return true;
}


bool ASC0_Detect(unsigned char *module, unsigned long length)
{
    int j, j1;
    unsigned char j3;
    //int delta;
    ASC0_File *header0 = (ASC0_File *)module;
    
         
   
    if(length < 9)
        return false;
        
    //delta = ASC0_PatternsPointers - header0->ASC0_Number_Of_Positions;
    //if(delta < 9 || delta > 72)
    //    return false;
        
    //return 1;    
        
    if(ASC0_PatternsPointers> length)
        return false;
    if(ASC0_SamplesPointers> length)
        return false;
    if(ASC0_OrnamentsPointers> length)
        return false;

  

    j = ay_sys_getword(&module[ASC0_SamplesPointers]);
    if(j != 0x40)
        return false;
    j = ay_sys_getword(&module[ASC0_OrnamentsPointers]);
    if(j != 0x40)
        return false;

  

    j3 = 0;
    for(j1 = 0; j1 < header0->ASC0_Number_Of_Positions; j1++)
        if(j3 < header0->ASC0_Positions[j1])
            j3 = header0->ASC0_Positions[j1];

    j = ay_sys_getword(&module[ASC0_PatternsPointers]);
    if(j != (j3 + 1) * 6)
        return false;
        
  
        
    j = ay_sys_getword(&module[ASC0_OrnamentsPointers + 0x40 - 2]);
    j += ASC0_OrnamentsPointers;
    while((j < length) && (j < 65535) && ((module[j] & 0x40) == 0))
        j += 2;

    if(j > 65534)
        return false;    
        
    if(j >= (length+512))
        return false;
        
    pp=3;
        
    return true;
}




bool ASC_Detect(unsigned char *module, unsigned int length, AYSongInfo * s)
{
  pp =0;
  offset = 0;

      if(!ASC1_Detect(module, length))
       if(!ASC0_Detect(module, length))              
         return false;
            
      if (!pp)
	   strcpy(s->player, "ASC Sound Master");	

      if (pp==3)
	  strcpy(s->player, "AS0");        
            
    return true;

}


void FN(AYSongInfo * info)
{
 char i;

    strncpy(info->Name, info->filename, 8);
    
    for (i=0; i<8; i++)
      if (info->Name[i]=='.')
        info->Name[i]=0;
}

void PSG_GetInfo(AYSongInfo * info)
{
    memcpy(&info->len, &info->module[4], 2);
    FN(info);        
}


bool PSG_Detect(unsigned char *module, unsigned int length, AYSongInfo * info)
{
    if (!memcmp (module, "XPSG", 4))
      {
        strcpy (info->player, "XPSG");
        return true;
      }
    
    return false;
}




/////////////////////////////////////////////////
///////////////////////////////////////////////////
/////////////////////////////////////////////////////








/* This player module was ported from:
 AY-3-8910/12 Emulator
 Version 3.0 for Windows 95
 Author Sergey Vladimirovich Bulba
 (c)1999-2004 S.V.Bulba
 */

const unsigned short SQT_Table[] =
{ 0xd5d, 0xc9c, 0xbe7, 0xb3c, 0xa9b, 0xa02, 0x973, 0x8eb, 0x86b, 0x7f2, 0x780, 0x714, 0x6ae, 0x64e, 0x5f4, 0x59e, 0x54f, 0x501, 0x4b9, 0x475, 0x435, 0x3f9, 0x3c0, 0x38a, 0x357, 0x327, 0x2fa, 0x2cf, 0x2a7, 0x281, 0x25d, 0x23b, 0x21b, 0x1fc, 0x1e0, 0x1c5, 0x1ac, 0x194, 0x17d, 0x168, 0x153, 0x140, 0x12e, 0x11d, 0x10d, 0xfe, 0xf0, 0xe2, 0xd6, 0xca, 0xbe, 0xb4, 0xaa, 0xa0, 0x97, 0x8f, 0x87, 0x7f, 0x78, 0x71, 0x6b, 0x65, 0x5f, 0x5a, 0x55, 0x50, 0x4c, 0x47, 0x43, 0x40, 0x3c, 0x39, 0x35, 0x32, 0x30, 0x2d, 0x2a, 0x28, 0x26, 0x24, 0x22, 0x20, 0x1e, 0x1c, 0x1b, 0x19, 0x18, 0x16, 0x15, 0x14, 0x13, 0x12, 0x11, 0x10, 0xf, 0xe };

typedef struct 
{
    unsigned char SQT_Size0, SQT_Size1;
    unsigned char SQT_SamplesPointer0, SQT_SamplesPointer1;
    unsigned char SQT_OrnamentsPointer0, SQT_OrnamentsPointer1;
    unsigned char SQT_PatternsPointer0, SQT_PatternsPointer1;
    unsigned char SQT_PositionsPointer0, SQT_PositionsPointer1;
    unsigned char SQT_LoopPointer0, SQT_LoopPointer1;
} SQT_File;

#define SQT_Size0 (unsigned int)(header->SQT_Size0 | (header->SQT_Size0 << 8))
#define SQT_SamplesPointer (unsigned int)(header->SQT_SamplesPointer0 | (header->SQT_SamplesPointer1 << 8))
#define SQT_OrnamentsPointer (unsigned int)(header->SQT_OrnamentsPointer0 | (header->SQT_OrnamentsPointer1 << 8))
#define SQT_PatternsPointer (unsigned int)(header->SQT_PatternsPointer0 | (header->SQT_PatternsPointer1 << 8))
#define SQT_PositionsPointer (unsigned int)(header->SQT_PositionsPointer0 | (header->SQT_PositionsPointer1 << 8))
#define SQT_LoopPointer (unsigned int)(header->SQT_LoopPointer0 | (header->SQT_LoopPointer1 << 8))

#define MAKE_PWORD(x) (unsigned short *)(x)

typedef struct 
{
    unsigned short Address_In_Pattern, SamplePointer, Point_In_Sample, OrnamentPointer, Point_In_Ornament, Ton, ix27;
    unsigned char Volume, Amplitude, Note, ix21;
    short Ton_Slide_Step, Current_Ton_Sliding;
    char Sample_Tik_Counter, Ornament_Tik_Counter, Transposit;
    bool Enabled, Envelope_Enabled, Ornament_Enabled, Gliss, MixNoise, MixTon, b4ix0, b6ix0, b7ix0;
} SQT_Channel_Parameters;

typedef struct 
{
    unsigned char Delay, DelayCounter, Lines_Counter;
    unsigned short Positions_Pointer;
}SQT_Parameters;

typedef struct 
{
    SQT_Parameters SQT;
    SQT_Channel_Parameters SQT_A, SQT_B, SQT_C;
} SQT_SongInfo;

#define SQT_A ((SQT_SongInfo *)info->data)->SQT_A
#define SQT_B ((SQT_SongInfo *)info->data)->SQT_B
#define SQT_C ((SQT_SongInfo *)info->data)->SQT_C
#define SQT ((SQT_SongInfo *)info->data)->SQT

bool SQT_PreInit(char * info)
{
    unsigned char *module = info;
    SQT_File *header = (SQT_File *)module;
    long i, i1, i2;
    unsigned long j2;
    unsigned short *pwrd;
    
    
    i = (unsigned int)SQT_SamplesPointer - 10;
    
    if(i < 0)
    {
      //  s->len = 21;
        return false;
     }
        
    i1 = 0;
    i2 = (unsigned int)SQT_PositionsPointer - i;
    
    if(i2 < 0)
    {
   //   s->len = i=2;
        return false;
    }
    
    while(module[i2] != 0)
    {
        if(i2 > (65536 - 8))
        {
       //   s->len = 23;
            return false;
         }
            
        if(i1 < (module[i2] & 0x7f))
            i1 = module[i2] & 0x7f;
        i2 += 2;
        if(i1 < (module[i2] & 0x7f))
            i1 = module[i2] & 0x7f;
        i2 += 2;
        if(i1 < (module[i2] & 0x7f))
            i1 = module[i2] & 0x7f;
        i2 += 3;
    }
    j2 = (unsigned long)(&module[65535]);
    pwrd = MAKE_PWORD(&header->SQT_SamplesPointer0);
    i1 = (SQT_PatternsPointer - i + i1 * 2) / 2;

    if(i1 < 1)
    {
    //  s->len = 24;
        return false;
     }
      
        
    for(i2 = 1; i2 <= i1; i2++)
    {
    /*
        if((unsigned long)(pwrd) >= j2)
        {
          s->len = 25;
            return false;
        }    
    
        if(*pwrd < i)
        {
          s->len = 26;
            return false;
        }   
      */
            
        *pwrd -= i;
        pwrd++;
    }
    
    
    return true;
}

SQT_SongInfo SQT_SI;

void SQT_Init(AYSongInfo * info)
{
    unsigned char *module = info->module;
    SQT_File *header = (SQT_File *)module;

    if(!SQT_PreInit(info->module))
        return;

   
    info->data = &SQT_SI;
 
    SQT_A.Ton = 0;
    SQT_A.Envelope_Enabled = false;
    SQT_A.Ornament_Enabled = false;
    SQT_A.Gliss = false;
    SQT_A.Enabled = false;

    SQT_B.Ton = 0;
    SQT_B.Envelope_Enabled = false;
    SQT_B.Ornament_Enabled = false;
    SQT_B.Gliss = false;
    SQT_B.Enabled = false;

    SQT_C.Ton = 0;
    SQT_C.Envelope_Enabled = false;
    SQT_C.Ornament_Enabled = false;
    SQT_C.Gliss = false;
    SQT_C.Enabled = false;

    SQT.DelayCounter = 1;
    SQT.Delay = 1;
    SQT.Lines_Counter = 1;
    SQT.Positions_Pointer = SQT_PositionsPointer;

    //ay_resetay(&info, 0);
}

void SQT_Call_LC1D1(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned short * Ptr, unsigned char a)
{
    unsigned char *module = info->module;
    ((*Ptr))++;
    if(chan->b6ix0)
    {
        chan->Address_In_Pattern = (unsigned short)(((*Ptr)) + 1);
        chan->b6ix0 = false;
    }
    switch(a - 1)
    {
        case 0:
            if(chan->b4ix0)
                chan->Volume = module[((*Ptr))] & 15;
            break;
        case 1:
            if(chan->b4ix0)
                chan->Volume = (chan->Volume + module[((*Ptr))]) & 15;
            break;
        case 2:
            if(chan->b4ix0)
            {
                SQT_A.Volume = module[((*Ptr))];
                SQT_B.Volume = module[((*Ptr))];
                SQT_C.Volume = module[((*Ptr))];
            }
            break;
        case 3:
            if(chan->b4ix0)
            {
                SQT_A.Volume = (SQT_A.Volume + module[((*Ptr))]) & 15;
                SQT_B.Volume = (SQT_B.Volume + module[((*Ptr))]) & 15;
                SQT_C.Volume = (SQT_C.Volume + module[((*Ptr))]) & 15;
            }
            break;
        case 4:
            if(chan->b4ix0)
            {
                SQT.DelayCounter = module[((*Ptr))] & 31;
                if(SQT.DelayCounter == 0)
                    SQT.DelayCounter = 32;
                SQT.Delay = SQT.DelayCounter;
            }
            break;
        case 5:
            if(chan->b4ix0)
            {
                SQT.DelayCounter = (SQT.DelayCounter + module[((*Ptr))]) & 31;
                if(SQT.DelayCounter == 0)
                    SQT.DelayCounter = 32;
                SQT.Delay = SQT.DelayCounter;
            }
            break;
        case 6:
            chan->Current_Ton_Sliding = 0;
            chan->Gliss = true;
            chan->Ton_Slide_Step = -module[((*Ptr))];
            break;
        case 7:
            chan->Current_Ton_Sliding = 0;
            chan->Gliss = true;
            chan->Ton_Slide_Step = module[((*Ptr))];
            break;
        default:
            chan->Envelope_Enabled = true;
            ay_writeay(AY_ENV_SHAPE, (a - 1) & 15);
            ay_writeay(AY_ENV_FINE, module[((*Ptr))]);
            break;
    }
}

void SQT_Call_LC2A8(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned char a)
{
    unsigned char *module = info->module;
    SQT_File *header = (SQT_File *)module;
    chan->Envelope_Enabled = false;
    chan->Ornament_Enabled = false;
    chan->Gliss = false;
    chan->Enabled = true;
    chan->SamplePointer = ay_sys_getword(&module[a * 2 + SQT_SamplesPointer]);
    chan->Point_In_Sample = chan->SamplePointer + 2;
    chan->Sample_Tik_Counter = 32;
    chan->MixNoise = true;
    chan->MixTon = true;
}

void SQT_Call_LC2D9(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned char a)
{
    unsigned char *module = info->module;
    SQT_File *header = (SQT_File *)module;
    chan->OrnamentPointer = ay_sys_getword(&module[a * 2 + SQT_OrnamentsPointer]);
    chan->Point_In_Ornament = chan->OrnamentPointer + 2;
    chan->Ornament_Tik_Counter = 32;
    chan->Ornament_Enabled = true;
}

void SQT_Call_LC283(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned short * Ptr)
{
    unsigned char *module = info->module;
    unsigned char val = module[(*Ptr)];
    if(val <= 0x7f)
    {
        SQT_Call_LC1D1(info, chan, Ptr, val);
    }
    else if(val >= 0x80)
    {
        if(((val >> 1) & 31) != 0)
            SQT_Call_LC2A8(info, chan, (val >> 1) & 31);
        if((val & 64) != 0)
        {
            int Temp = module[(*Ptr) + 1] >> 4;
            if((val & 1) != 0)
                Temp = Temp | 16;
            if(Temp != 0)
                SQT_Call_LC2D9(info, chan, Temp);
            (*Ptr)++;
            if((module[(*Ptr)] & 15) != 0)
                SQT_Call_LC1D1(info, chan, Ptr, module[(*Ptr)] & 15);
        }
    }
    (*Ptr)++;
}

void SQT_Call_LC191(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned short * Ptr)
{
    unsigned char *module = info->module;
    (*Ptr) = chan->ix27;
    chan->b6ix0 = false;
    if(module[(*Ptr)] <= 0x7f)
    {
        (*Ptr)++;
        SQT_Call_LC283(info, chan, Ptr);
    }
    else if(module[(*Ptr)] >= 0x80)
    {
        SQT_Call_LC2A8(info, chan, module[(*Ptr)] & 31);
    }

}

void SQT_PatternInterpreter(AYSongInfo * info, SQT_Channel_Parameters * chan)
{
    unsigned char *module = info->module;
    unsigned short Ptr = 0;
    unsigned char val;
    
    if(chan->ix21 != 0)
    {
        chan->ix21--;
        if(chan->b7ix0)
            SQT_Call_LC191(info, chan, &Ptr);
        return;
    }
    Ptr = chan->Address_In_Pattern;
    chan->b6ix0 = true;
    chan->b7ix0 = false;
    while(true)
    {
        val = module[Ptr];
        if(val <= 0x5f)
        {
            chan->Note = module[Ptr];
            chan->ix27 = Ptr;
            Ptr++;
            SQT_Call_LC283(info, chan, &Ptr);
            if(chan->b6ix0)
                chan->Address_In_Pattern = Ptr;
            break;
        }
        else if(val >= 0x60 && val <= 0x6e)
        {
            SQT_Call_LC1D1(info, chan, &Ptr, module[Ptr] - 0x60);
            break;
        }
        else if(val >= 0x6f && val <= 0x7f)
        {
            chan->MixNoise = false;
            chan->MixTon = false;
            chan->Enabled = false;
            if(val != 0x6f)
                SQT_Call_LC1D1(info, chan, &Ptr, module[Ptr] - 0x6f);
            else
                chan->Address_In_Pattern = Ptr + 1;
            break;
        }
        else if(val >= 0x80 && val <= 0xbf)
        {
            chan->Address_In_Pattern = Ptr + 1;
            if(val <= 0x9f)
            {
                if((val & 16) == 0)
                    chan->Note += val & 15;
                else
                    chan->Note -= val & 15;
            }
            else
            {
                chan->ix21 = val & 15;
                if((val & 16) == 0)
                    break;
                if(chan->ix21 != 0)
                    chan->b7ix0 = true;
            }
            SQT_Call_LC191(info, chan, &Ptr);
            break;
        }
        else if(val >= 0xc0)
        {
            chan->Address_In_Pattern = Ptr + 1;
            chan->ix27 = Ptr;
            SQT_Call_LC2A8(info, chan, val & 31);
            break;
        }
    }
}

void SQT_GetRegisters(AYSongInfo * info, SQT_Channel_Parameters * chan, unsigned char * TempMixer)
{
    unsigned char noise;
    unsigned char *module = info->module;
    unsigned char j, b0, b1;
    (*TempMixer) = (*TempMixer) << 1;
    if(chan->Enabled)
    {
        b0 = module[chan->Point_In_Sample];
        chan->Amplitude = b0 & 15;
        if(chan->Amplitude != 0)
        {
            chan->Amplitude -= chan->Volume;
            if((signed char)(chan->Amplitude) < 0)
                chan->Amplitude = 0;
        }
        else if(chan->Envelope_Enabled)
            chan->Amplitude = 16;
        b1 = module[chan->Point_In_Sample + 1];
        if((b1 & 32) != 0)
        {
            (*TempMixer) |= 8;
            noise = (b0 & 0xf0) >> 3;
            if((signed char)(b1) < 0)
                noise++;
            ay_writeay(AY_NOISE_PERIOD, noise);
        }
        if((b1 & 64) != 0)
        {
            (*TempMixer) |= 1;
        }
        j = chan->Note;
        if(chan->Ornament_Enabled)
        {
            j += module[chan->Point_In_Ornament];
            chan->Ornament_Tik_Counter--;
            if(chan->Ornament_Tik_Counter == 0)
            {
                if(module[chan->OrnamentPointer] != 32)
                {
                    chan->Ornament_Tik_Counter = module[chan->OrnamentPointer + 1];
                    chan->Point_In_Ornament = chan->OrnamentPointer + 2 + module[chan->OrnamentPointer];
                }
                else
                {
                    chan->Ornament_Tik_Counter = module[chan->SamplePointer + 1];
                    chan->Point_In_Ornament = chan->OrnamentPointer + 2 + module[chan->SamplePointer];
                }
            }
            else
                chan->Point_In_Ornament++;
        }
        j += chan->Transposit;
        if(j > 0x5f)
            j = 0x5f;
        if((b1 & 16) == 0)
            chan->Ton = SQT_Table[j] - (((unsigned short)(b1 & 15) << 8) + module[chan->Point_In_Sample + 2]);
        else
            chan->Ton = SQT_Table[j] + (((unsigned short)(b1 & 15) << 8) + module[chan->Point_In_Sample + 2]);
        chan->Sample_Tik_Counter--;
        if(chan->Sample_Tik_Counter == 0)
        {
            chan->Sample_Tik_Counter = module[chan->SamplePointer + 1];
            if(module[chan->SamplePointer] == 32)
            {
                chan->Enabled = false;
                chan->Ornament_Enabled = false;
            }
            chan->Point_In_Sample = chan->SamplePointer + 2 + module[chan->SamplePointer] * 3;
        }
        else
            chan->Point_In_Sample += 3;
        if(chan->Gliss)
        {
            chan->Ton += chan->Current_Ton_Sliding;
            chan->Current_Ton_Sliding += chan->Ton_Slide_Step;
        }
        chan->Ton = chan->Ton & 0xfff;
    }
    else
        chan->Amplitude = 0;
}

void SQT_Play(AYSongInfo * info)
{
    unsigned char *module = info->module;
    SQT_File *header = (SQT_File *)module;
    unsigned char TempMixer;

    
    // return;

    if(--SQT.DelayCounter == 0)
    {
        SQT.DelayCounter = SQT.Delay;
        if(--SQT.Lines_Counter == 0)
        {
            if(module[SQT.Positions_Pointer] == 0)
                SQT.Positions_Pointer = SQT_LoopPointer;
            if((signed char)(module[SQT.Positions_Pointer]) < 0)
                SQT_C.b4ix0 = true;
            else
                SQT_C.b4ix0 = false;
            SQT_C.Address_In_Pattern = ay_sys_getword(&module[(unsigned char)(module[SQT.Positions_Pointer] * 2) + SQT_PatternsPointer]);
            SQT.Lines_Counter = module[SQT_C.Address_In_Pattern];
            SQT_C.Address_In_Pattern++;
            SQT.Positions_Pointer++;
            SQT_C.Volume = module[SQT.Positions_Pointer] & 15;
            if((module[SQT.Positions_Pointer] >> 4) < 9)
                SQT_C.Transposit = module[SQT.Positions_Pointer] >> 4;
            else
                SQT_C.Transposit = -((module[SQT.Positions_Pointer] >> 4) - 9) - 1;
            SQT.Positions_Pointer++;
            SQT_C.ix21 = 0;

            if(module[SQT.Positions_Pointer] == 0)
                SQT.Positions_Pointer = SQT_LoopPointer;
            if((signed char)(module[SQT.Positions_Pointer]) < 0)
                SQT_B.b4ix0 = true;
            else
                SQT_B.b4ix0 = false;
            SQT_B.Address_In_Pattern = ay_sys_getword(&module[(unsigned char)(module[SQT.Positions_Pointer] * 2) + SQT_PatternsPointer]) + 1;
            SQT.Positions_Pointer++;
            SQT_B.Volume = module[SQT.Positions_Pointer] & 15;
            if((module[SQT.Positions_Pointer] >> 4) < 9)
                SQT_B.Transposit = module[SQT.Positions_Pointer] >> 4;
            else
                SQT_B.Transposit = -((module[SQT.Positions_Pointer] >> 4) - 9) - 1;
            SQT.Positions_Pointer++;
            SQT_B.ix21 = 0;

            if(module[SQT.Positions_Pointer] == 0)
                SQT.Positions_Pointer = SQT_LoopPointer;
            if((signed char)(module[SQT.Positions_Pointer]) < 0)
                SQT_A.b4ix0 = true;
            else
                SQT_A.b4ix0 = false;
            SQT_A.Address_In_Pattern = ay_sys_getword(&module[(unsigned char)(module[SQT.Positions_Pointer] * 2) + SQT_PatternsPointer]) + 1;
            SQT.Positions_Pointer++;
            SQT_A.Volume = module[SQT.Positions_Pointer] & 15;
            if((module[SQT.Positions_Pointer] >> 4) < 9)
                SQT_A.Transposit = module[SQT.Positions_Pointer] >> 4;
            else
                SQT_A.Transposit = -((module[SQT.Positions_Pointer] >> 4) - 9) - 1;
            SQT.Positions_Pointer++;
            SQT_A.ix21 = 0;

            SQT.Delay = module[SQT.Positions_Pointer];
            SQT.DelayCounter = SQT.Delay;
            SQT.Positions_Pointer++;
        }
        SQT_PatternInterpreter(info, &SQT_C);
        SQT_PatternInterpreter(info, &SQT_B);
        SQT_PatternInterpreter(info, &SQT_A);
    }

    TempMixer = 0;
    SQT_GetRegisters(info, &SQT_C, &TempMixer);
    SQT_GetRegisters(info, &SQT_B, &TempMixer);
    SQT_GetRegisters(info, &SQT_A, &TempMixer);
    TempMixer = (-(TempMixer + 1)) & 0x3f;

    if(!SQT_A.MixNoise)
        TempMixer |= 8;
    if(!SQT_A.MixTon)
        TempMixer |= 1;

    if(!SQT_B.MixNoise)
        TempMixer |= 16;
    if(!SQT_B.MixTon)
        TempMixer |= 2;

    if(!SQT_C.MixNoise)
        TempMixer |= 32;
    if(!SQT_C.MixTon)
        TempMixer |= 4;

    ay_writeay(AY_MIXER, TempMixer);
    ay_writeay(AY_CHNL_A_FINE, SQT_A.Ton & 0xff);
    ay_writeay(AY_CHNL_A_COARSE, (SQT_A.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_B_FINE, SQT_B.Ton & 0xff);
    ay_writeay(AY_CHNL_B_COARSE, (SQT_B.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_C_FINE, SQT_C.Ton & 0xff);
    ay_writeay(AY_CHNL_C_COARSE, (SQT_C.Ton >> 8) & 0xf);
    ay_writeay(AY_CHNL_A_VOL, SQT_A.Amplitude);
    ay_writeay(AY_CHNL_B_VOL, SQT_B.Amplitude);
    ay_writeay(AY_CHNL_C_VOL, SQT_C.Amplitude);
}




void SQT_GetChannelInfo(AYSongInfo * info, unsigned char * new_b,  char * new_a1, unsigned short * new_j1, unsigned short * new_cptr, bool * new_f71, bool * new_f61, bool * new_f41, unsigned short * new_j22, unsigned char chnl_num)
{
    unsigned char *module = info->module;
    unsigned char va1, va2, va3, va4;
   
    char a = 0;
    
   
    //gotoxy (5, 5);
   
    if(*new_a1 != 0)
    {
        (*new_a1) --;
        
        //printf ("01");
        
        if(*new_f71)
        {
            *new_cptr = *new_j22;
            *new_f61 = false;
            if(module[*new_cptr] <= 0x7f)
            {
                (*new_cptr) ++;
		va1 = module[*new_cptr];
                if(va1 <= 0x7f)
                {
                    (*new_cptr) ++;
                    if(*new_f61)
                        *new_j1 = *new_cptr + 1;
                    switch(module[*new_cptr - 1] - 1)
                    {
                        case 4:
                            if(*new_f41)
                            {
                                *new_b = module[*new_cptr] & 31;
                                if(*new_b == 0)
				    *new_b = 32;
                            }
                            break;
                        case 5:
                            if(*new_f41)
                            {
				*new_b = (*new_b + module[*new_cptr]) & 31;
                                if(*new_b == 0)
                                    *new_b = 32;
                            }
                            break;
                        default:
                            break;
		    }
                }
                else if(va1 >= 0x80)
                {
                    if((va1 & 64) != 0)
                    {
                        (*new_cptr)++;
                        if((module[*new_cptr] & 15) != 0)
                        {
                            (*new_cptr)++;
                            if(*new_f61)
                                *new_j1 = *new_cptr + 1;
			    switch((module[*new_cptr - 1] & 15) - 1)
			    {
                                case 4:
                                    if(*new_f41)
                                    {
                                        *new_b = module[*new_cptr] & 31;
                                        if(*new_b == 0)
                                            *new_b = 32;
                                    }
                                    break;
                                case 5:
                                    if(*new_f41)
                                    {
                                        *new_b = (*new_b + module[*new_cptr]) & 31;
					if(*new_b == 0)
                                            *new_b = 32;
                                    }
                                    break;
                                default:
				    break;
                            }
                        }
                    }
                }
            }
        }
    }
    else
    {
     //printf ("02");
    
        *new_cptr = *new_j1;
        *new_f61 = true;
        *new_f71 = false;
        while(true)
        {
            va2 = module[*new_cptr];
            
           // gotoxy (20, 5);
            //printf ("%05d %02x %d  ", *new_cptr, va2, a++);
            
            if(va2 <= 0x5f)
            {
                *new_j22 = *new_cptr;
		(*new_cptr) ++;
				
		
                va3 = module[*new_cptr];
		if(va3 <= 0x7f)
                {
                    (*new_cptr) ++;
                    if(*new_f61)
                    {
                        *new_j1 = *new_cptr + 1;
                        *new_f61 = false;
                    }
                    switch(module[*new_cptr - 1] - 1)
                    {
                        case 4:
                            if(*new_f41)
                            {
				*new_b = module[*new_cptr] & 31;
                                if(*new_b == 0)
                                    *new_b = 32;
                            }
			    break;
                        case 5:
                            if(*new_f41)
                            {
                                *new_b = (*new_b + module[*new_cptr]) & 31;
                                if(*new_b == 0)
                                    *new_b = 32;
                            }
                            break;
			default:
                            break;
                    }
                }
                else if(va3 >= 0x80)
                {
                    // printf ("03");
                
                    if((module[*new_cptr] & 64) != 0)
                    {
                        (*new_cptr) ++;
                        if((module[*new_cptr] & 15) != 0)
			{
                            (*new_cptr) ++;
                            if(*new_f61)
			    {
                                *new_j1 = *new_cptr + 1;
                                *new_f61 = false;
                            }
                            switch((module[*new_cptr - 1] & 15) - 1)
                            {
                                case 4:
                                    if(*new_f41)
                                    {
                                        *new_b = module[*new_cptr] & 31;
                                        if(*new_b == 0)
                                            *new_b = 32;
                                    }
				    break;
                                case 5:
                                    if(*new_f41)
				    {
                                        *new_b = (*new_b + module[*new_cptr]) & 31;
                                        if(*new_b == 0)
                                            *new_b = 32;
                                    }
                                    break;
                                default:
                                    break;
                            }

			}
                    }
                }
                (*new_cptr) ++;
                if(*new_f61)
                    *new_j1 = *new_cptr;
                break;
            }
            else if(va2 >= 0x60 && va2 <= 0x6e)
	    {
	       // printf ("04");
	    
                (*new_cptr) ++;
                if(*new_f61)
                    *new_j1 = *new_cptr + 1;
		switch(module[*new_cptr - 1] - 0x60 - 1)
                {
                    case 4:
                        if(*new_f41)
                        {
                            *new_b = module[*new_cptr] & 31;
                            if(*new_b == 0)
                                *new_b = 32;
                        }
                        break;
                    case 5:
                        if(*new_f41)
                        {
			    *new_b = (*new_b + module[*new_cptr]) & 31;
                            if(*new_b == 0)
				*new_b = 32;
                        }
                        break;
                    default:
                        break;
                }
                break;
            }
            else if(va2 >= 0x6f && va2 <= 0x7f)
            {
                // printf ("05");
            
                if(module[*new_cptr] != 0x6f)
		{
                    (*new_cptr) ++;
                    if(*new_f61)
                        *new_j1 = *new_cptr + 1;
                    switch(module[*new_cptr - 1] - 0x6f - 1)
                    {
                        case 4:
                            if(*new_f41)
			    {
                                *new_b = module[*new_cptr] & 31;
                                if(*new_b == 0)
                                    *new_b = 32;
                            }
			    break;
                        case 5:
                            if(*new_f41)
                            {
                                *new_b = (*new_b + module[*new_cptr]) & 31;
                                if(*new_b == 0)
                                    *new_b = 32;
                            }
                            break;
                        default:
                            break;
                    }
                }
		else
		    *new_j1 = *new_cptr + 1;
                break;
            }
            else if(va2 >= 0x80 && va2 <= 0xbf)
            {
                 //printf ("06");
            
                *new_j1 = *new_cptr + 1;
                if(chnl_num == 1)
                {
                    if(va2 >= 0xa0)
                    {
                        *new_a1 = module[*new_cptr] & 15;
                        if((module[*new_cptr] & 16) == 0)
			    break;
                        if(*new_a1 != 0)
                            *new_f71 = true;
                    }
                }
                else if(chnl_num == 2 || chnl_num == 3)
                {
                   // printf ("07");
                
		    if(va2 > 0x9f)
                    {
                        *new_a1 = module[*new_cptr] & 15;
                        if((module[*new_cptr] & 16) == 0)
                            break;
                        if(*new_a1 != 0)
			    *new_f71 = true;
                    }
                }
                *new_cptr = *new_j22;
                *new_f61 = false;
                if(module[*new_cptr] <= 0x7f)
                {
                    (*new_cptr) ++;
                    va4 = module[*new_cptr];
                    if(va4 <= 0x7f)
                    {
                        (*new_cptr) ++;
                        if(*new_f61)
			    *new_j1 = *new_cptr + 1;
                        switch(module[*new_cptr - 1] - 1)
                        {
                            case 4:
                                if(*new_f41)
                                {
                                    *new_b = module[*new_cptr] & 31;
                                    if(*new_b == 0)
                                        *new_b = 32;
                                }
                                break;
                            case 5:
                                if(*new_f41)
				{
                                    *new_b = (*new_b + module[*new_cptr]) & 31;
                                    if(*new_b == 0)
                                        *new_b = 32;
                                }
                                break;
			    default:
                                break;
                        }
                    }
                    else if(va4 >= 0x80)
                    {
                        // printf ("08");
                    
                        if((module[*new_cptr] & 64) != 0)
			{
                            (*new_cptr) ++;
                            if((module[*new_cptr] & 15) != 0)
                            {
                                (*new_cptr) ++;
                                if(*new_f61)
                                    *new_j1 = *new_cptr + 1;
                                switch((module[*new_cptr - 1] & 15) - 1)
                                {
                                    case 4:
                                        if(*new_f41)
                                        {
					    *new_b = module[*new_cptr] & 31;
					    if(*new_b == 0)
                                                *new_b = 32;
                                        }
                                        break;
                                    case 5:
                                        if(*new_f41)
                                        {
                                            *new_b = (*new_b + module[*new_cptr]) & 31;
                                            if(*new_b == 0)
                                                *new_b = 32;
                                        }
                                        break;
                                    default:
					break;
                                }

                            }
                        }
		    }

                }
                break;
            }
            else if(va2 >= 0xc0)
            {
                 //printf ("09");
            
                *new_j1 = *new_cptr + 1;
		*new_j22 = *new_cptr;
                break;
            }
        }
    }
}





void SQT_GetInfo(AYSongInfo * info)
{
  
    unsigned char *module = info->module;
    
    SQT_File *header = (SQT_File *)module;
    unsigned char b;
    unsigned long tm = 0;
    long i;
    char a1, a2, a3;
    unsigned short j1, j2, j3;
    unsigned short pptr, cptr;
    bool f71, f72, f73, f61, f62, f63, f41, f42, f43, flg;
    unsigned short j11, j22, j33;
    unsigned char limit;
    
    
    f71 = f72 = f73 = f61 = f62 = f63 = f41 = f42 = f43 = flg = false;
    j11 = j22 = j33 = 0;
    
    if(!SQT_PreInit(info->module))
    {
        info->len = 0;
        return;
    }

    pptr = SQT_PositionsPointer;
    while(module[pptr] != 0)
    {
        //if(pptr == SQT_LoopPointer)
        //    info->Loop = tm;
            
        f41 = (module[pptr] & 128) ? true : false;
        j1 = ay_sys_getword(&module[(unsigned char)(module[pptr] * 2) + SQT_PatternsPointer]);
        j1++;
        pptr += 2;
        f42 = (module[pptr] & 128) ? true : false;
        j2 = ay_sys_getword(&module[(unsigned char)(module[pptr] * 2) + SQT_PatternsPointer]);
        j2++;
        pptr += 2;
        f43 = (module[pptr] & 128) ? true : false;
        j3 = ay_sys_getword(&module[(unsigned char)(module[pptr] * 2) + SQT_PatternsPointer]);
        j3++;
        pptr += 2;
        b = module[pptr];
        pptr++;
        a1 = a2 = a3 = 0;
        limit = module[j1 - 1];
        for(i = 0; i < limit; i++)
        {
            //gotoxy(5, 5);
           // printf ("2                       ");
            SQT_GetChannelInfo(info, &b, &a1, &j1, &cptr, &f71, &f61, &f41, &j11, 1);
	    
	    //gotoxy(5, 5);
	    //printf ("3                       ");	    
	    SQT_GetChannelInfo(info, &b, &a2, &j2, &cptr, &f72, &f62, &f42, &j22, 2);
	    
	    //gotoxy(5, 5);
	    //printf ("4                       ");
	    SQT_GetChannelInfo(info, &b, &a3, &j3, &cptr, &f73, &f63, &f43, &j33, 3);
            
            
          
            tm += b;
            
            //gotoxy(0, 5);
            //printf("%d                              ", tm);
        }
    }
    
    info->len = tm;
    
    FN(info); 
}


bool SQT_Detect(unsigned char *module, unsigned int length, AYSongInfo * s)
{
    int j, j1, j2, j3;
    SQT_File *header = (SQT_File *)module;
    unsigned short *pwrd;
    long F_Length;
    
    int PD_rv;
    
    
    //return false;
    
    if(length < 17)
    {
     // s->len = 1;
        return false;
        }
        
    if((unsigned int)SQT_SamplesPointer < 10)
    {
    //s->len = 2;
        return false;
    }
    
    if(SQT_OrnamentsPointer <= SQT_SamplesPointer)
   {
 //  s->len = 3;
        return false;
    }
    
    if(SQT_PatternsPointer < SQT_OrnamentsPointer)
 {
// s->len = 4;
        return false;
  }
    
    if(SQT_PositionsPointer <= SQT_PatternsPointer)
    {
   // s->len = 5;
        return false;
    }
    
    if(SQT_LoopPointer < SQT_PositionsPointer)
     {
    // s->len = 6;
        return false;
}

    j = SQT_SamplesPointer - 10;
    if(SQT_LoopPointer - j >= length)
 {
 //s->len = 7;
        return false;
}

    j1 = SQT_PositionsPointer - j;
    if(module[j1] == 0)
 {
// s->len = 8;
        return false;
 }
 
    j2 = 0;
    while(module[j1] != 0)
    {
        if(j1 + 7 >= length)
        {
        //s->len = 9;
            return false;
         }   
  
        if(j2 < (module[j1] & 0x7f))
            j2 = module[j1] & 0x7f;
        j1 += 2;
        if(j2 < (module[j1] & 0x7f))
            j2 = module[j1] & 0x7f;
        j1 += 2;
        if(j2 < (module[j1] & 0x7f))
            j2 = module[j1] & 0x7f;
        j1 += 3;
    }

    pwrd = (unsigned short *)&module[SQT_SamplesPointer - j + 2];
    if(*pwrd - SQT_PatternsPointer - 2 != j2 * 2)
    {
   // s->len = 10;
        return false;
        }

    F_Length = j1 + 7;
    pwrd = (unsigned short *)&module[12];
    j2 = *pwrd;
    for(j1 = 1; j1 <= (SQT_OrnamentsPointer- SQT_SamplesPointer) / 2; j1++)
    {
        pwrd++;
        j3 = *pwrd;
        if( j3 - j2 != 0x62 )
        {
        //s->len = 11;
        return false;
        }
        
        j2 = j3;
    }

    for(j1 = 1; j1 <= (SQT_PatternsPointer - SQT_OrnamentsPointer) / 2; j1++)
    {
        pwrd++;
        j3 = *pwrd;
        if( j3 - j2 != 0x22) 
        {
        //s->len = 12;
        return false;
        }
        j2 = j3;
    }

    PD_rv = SQT_PreInit(module);
    
    if (!PD_rv)
      return 0;

    strcpy (s->player, "SQ Tracker");

    return  1;
}


